#ifndef UNN_LOCALE
#define UNN_LOCALE

#include "denise.h"
#include "UNN_Locale.h"

char* UNNPRIV_GetTextLine(FILE* filehandle)
{
	char textbuffer[255];
	char* textptr;
	do
	{
		fgets(textbuffer,sizeof(textbuffer)-1,filehandle);
	}
	while ((textbuffer[0]=='#') && (!feof(filehandle)));
	if (feof(filehandle)) return NULL;
	if (textbuffer[strlen(textbuffer)-1]=='\n') textbuffer[strlen(textbuffer)-1]='\0';
	if (textbuffer[strlen(textbuffer)-1]=='\r') textbuffer[strlen(textbuffer)-1]='\0';
	if (textptr=UNN_AllocMem(strlen(textbuffer)+1,MEMF_PUBLIC|MEMF_CLEAR))
	{
		strcpy(textptr,textbuffer);
		return textptr;
	}
	return NULL;
}

int OpenCatalog(struct DeniseHandle* handle, char* filename)
{
	FILE* filehandle;
	struct LocaleEntry* localenode;
   char *text;

	if (handle)
	{
		UNN_NewList((struct List*)&handle->LocaleList);
		if (filehandle=dat_file_open(handle,filename,"r"))
		{
			while (!feof(filehandle))
			{
//				if (localenode=(struct LocaleEntry*)UNN_AllocNode(sizeof(struct MinNode)))
				if (localenode=(struct LocaleEntry*)UNN_AllocNode(sizeof(struct LocaleEntry)))
				{
// wczytaj ID
					if (text=UNNPRIV_GetTextLine(filehandle))
               {
	               localenode->LocaleID=atoi(text);
                  free(text);
// wczytaj txt
						if (localenode->LocaleText=UNNPRIV_GetTextLine(filehandle))
						{
							UNN_AddTail((struct List*)&handle->LocaleList,(struct Node*)localenode);
//DeniseReport(handle,"ID: %d=%s",localenode->LocaleID,localenode->LocaleText);
                  }
						else UNN_FreeNode((struct Node*)localenode);
               }
               else UNN_FreeNode((struct Node*)localenode);
				}
			}
			fclose(filehandle);
			return OK;
		}
	}
	return FAIL;
}

void CloseCatalog(struct DeniseHandle* handle)
{
	struct MinNode *worknode;
	struct MinNode *nextnode;
	struct MinList* list;
	struct LocaleEntry* localenode;

	if (handle)
	{
		if (list=&handle->LocaleList)
		{
			worknode=(list->mlh_Head);
			while (nextnode=(worknode->mln_Succ))
			{
				localenode=(struct LocaleEntry*) worknode;
				UNN_FreeMem(localenode->LocaleText);
				UNN_Remove((struct Node *) worknode);
				UNN_FreeMem(worknode);
				worknode=nextnode;
         }
			UNN_NewList((struct List*)&handle->LocaleList);
		}
	}
}

char* UNN_GetLocaleString(struct DeniseHandle* handle, ULONG msgID, char* message)
{
	struct MinNode *worknode;
	struct MinNode *nextnode;
	struct MinList* list;
	struct LocaleEntry* localenode;

	if (handle)
	{
		if (list=&handle->LocaleList)
		{
			worknode=(list->mlh_Head);
         if (worknode)
         {
				while (nextnode=(worknode->mln_Succ))
				{
					localenode=(struct LocaleEntry*) worknode;
					if (msgID==localenode->LocaleID)
               {
//DeniseReport(handle,"founded: %d",msgID);
               	return localenode->LocaleText;
               }
					worknode=nextnode;
				}
         }
		}
	}
	return message;
}

#endif

