// ***************************************************************************************
//                                          COMMAND
// ***************************************************************************************

#include "denise.h"
#include "denise_protos.h"

// deklaracje prywatne

// ***************************************************************************************
// EXTERN                            void com_load_config(void)
// ***************************************************************************************
void com_load_config(struct DeniseHandle* handle,char *filename)
{
	FILE *stream;
	char *langdirfile=NULL;
	char temp[200];

	DeniseReport(handle,UNN_GetLocaleString(handle,MSG_LOADING_CONFIG,"odczyt konfiguracji z pliku '%s'"),filename);

	stream=dat_file_open(handle,filename,"r");
	if (stream==NULL)
	{
		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_ERROR_OPENING_FILE,"nie moge otworzyc pliku: '%s'"),filename);
		goto default_settings;
	}

   if (fscanf(stream,"%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%s\n%s\n%s\n%s\n",
		&(handle->syntaxparams.min_words),&(handle->syntaxparams.max_groups),
		&(handle->syntaxparams.max_fleks),&(handle->syntaxparams.max_words),&(handle->syntaxparams.max_clauses),
		&(handle->syntaxparams.first_clause),&(handle->syntaxparams.subject_first),
		&(handle->syntaxparams.min_prefix_len),&(handle->syntaxparams.prefix_check),&(handle->syntaxparams.remember_first),
		&(handle->syntaxparams.phrase_quality),&(handle->syntaxparams.structure_quality),&(handle->syntaxparams.function_quality),
		&(handle->viewparams.words),&(handle->viewparams.clause),&(handle->viewparams.syntax),&(handle->viewparams.syntax_time),
		&(handle->viewparams.preliminary_analysis),&(handle->viewparams.theme_analysis),&(handle->viewparams.interlocutory_analysis),
		&(handle->viewparams.logic_analysis),&(handle->viewparams.fact_analysis),&(handle->viewparams.unknown_words),&(handle->viewparams.conjunctions_analysis),
      &(handle->logbookparams.words),&(handle->logbookparams.clauses),&(handle->logbookparams.dialog),&(handle->logbookparams.reports),
      &(handle->Supervisor),
      &(handle->LanguagesDir),
      &(handle->LogicDir),
      &(handle->FactsDir),
      &(handle->LogbookDir)
      )==33)
		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DATA_LOADED,"dane odczytane"));
	else
	{
		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DATA_LOADING_ERROR,"blad odczytu danych: '%s'"),filename);
		fclose(stream);
		goto default_settings;
	}

	fclose(stream);

	asprintf(&langdirfile,"%s%s%s",handle->Prefix,handle->LanguagesDir,ACTIVE_LANGUAGE_FILE);
   if ((stream=dat_file_open(handle,langdirfile,"r"))==NULL)
	{
		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_ERROR_OPENING_FILE,"nie moge otworzyc pliku: '%s'"),langdirfile);
		if(langdirfile) free(langdirfile);
		goto default_settings;
	}
   if (fgets(temp,200,stream)==NULL)
	{
		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DATA_LOADING_ERROR,"blad odczytu danych: '%s'"),langdirfile);
		fclose(stream);
		if(langdirfile) free(langdirfile);
		goto default_settings;
	}
   temp[strlen(temp)-1]='\0';
	if (handle->language.name!=NULL) free(handle->language.name);
	handle->language.name=malloc(strlen(temp)+1);
   strcpy(handle->language.name,temp);

	DeniseReport(handle,UNN_GetLocaleString(handle,MSG_SELECTED_LANGUAGE,"aktualny jezyk: %s"),handle->language.name);
   fclose(stream);

	return;

	default_settings:
	DeniseReport(handle,UNN_GetLocaleString(handle,MSG_STANDARD_CONFIGURATION,"ustawienia standardowe"));
	if (handle->language.name!=NULL) free(handle->language.name);
	handle->language.name=malloc(7);
   sprintf(handle->language.name,"polski");
   handle->syntaxparams.min_words=2;
   handle->syntaxparams.min_groups=2;
   handle->syntaxparams.max_groups=99;
   handle->syntaxparams.max_fleks=2;
   handle->syntaxparams.min_prefix_len=3;
   handle->syntaxparams.prefix_check=1;
   handle->syntaxparams.prefix_check_mode=0;
   handle->syntaxparams.max_words=99;
   handle->syntaxparams.max_clauses=99; // 99
   handle->syntaxparams.first_clause=ON;
   handle->syntaxparams.subject_first=OFF;
   handle->syntaxparams.remember_first=ON;
   handle->syntaxparams.function_quality=100;
   handle->syntaxparams.structure_quality=100;
   handle->syntaxparams.phrase_quality=100;

	handle->viewparams.words=OFF;
   handle->viewparams.clause=OFF;
   handle->viewparams.syntax=OFF;
   handle->viewparams.syntax_time=OFF;
	handle->viewparams.preliminary_analysis=OFF;
   handle->viewparams.theme_analysis=OFF;
   handle->viewparams.interlocutory_analysis=OFF;
	handle->viewparams.logic_analysis=OFF;
   handle->viewparams.fact_analysis=OFF;
   handle->viewparams.unknown_words=OFF;
   handle->viewparams.conjunctions_analysis=OFF;

   handle->logbookparams.words=OFF;
   handle->logbookparams.clauses=OFF;
   handle->logbookparams.dialog=OFF;
   handle->logbookparams.reports=OFF;
   handle->Supervisor=ON;
   strcpy(handle->LanguagesDir,LANGUAGES_DIR);
   strcpy(handle->LogicDir,LOGIC_DIR);
   strcpy(handle->FactsDir,FACTS_DIR);
   strcpy(handle->LogbookDir,LOGBOOK_DIR);
}

// ***************************************************************************************
// EXTERN                            void com_save_config(void)
// ***************************************************************************************
void com_save_config(struct DeniseHandle* handle,char *filename)
{
	FILE *stream;
	char *langdirfile=NULL;

	DeniseReport(handle,UNN_GetLocaleString(handle,MSG_SAVING_CONFIG,"zapis konfiguracji do pliku '%s'"),filename);

	stream=dat_file_open(handle,filename,"w");
	if (stream==NULL)
	{
		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_ERROR_OPENING_FILE,"nie moge otworzyc pliku: '%s'"),filename);
		return;
	}

   if (fprintf(stream,"%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%s\n%s\n%s\n%s\n",
		handle->syntaxparams.min_words,handle->syntaxparams.max_groups,
		handle->syntaxparams.max_fleks,handle->syntaxparams.max_words,handle->syntaxparams.max_clauses,
		handle->syntaxparams.first_clause,handle->syntaxparams.subject_first,
		handle->syntaxparams.min_prefix_len,handle->syntaxparams.prefix_check,handle->syntaxparams.remember_first,
		handle->syntaxparams.phrase_quality,handle->syntaxparams.structure_quality,handle->syntaxparams.function_quality,
		handle->viewparams.words,handle->viewparams.clause,handle->viewparams.syntax,handle->viewparams.syntax_time,
		handle->viewparams.preliminary_analysis,handle->viewparams.theme_analysis,handle->viewparams.interlocutory_analysis,
		handle->viewparams.logic_analysis,handle->viewparams.fact_analysis,handle->viewparams.unknown_words,handle->viewparams.conjunctions_analysis,
      handle->logbookparams.words,handle->logbookparams.clauses,handle->logbookparams.dialog,handle->logbookparams.reports,handle->Supervisor,
      handle->LanguagesDir,
      handle->LogicDir,
      handle->FactsDir,
      handle->LogbookDir
      )<0)
		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DATA_SAVING_ERROR,"blad zapisu danych: '%s'"),filename);

	fclose(stream);

	// aktualny jezyk
	asprintf(&langdirfile,"%s%s%s",handle->Prefix,handle->LanguagesDir,ACTIVE_LANGUAGE_FILE);
   if ((stream=dat_file_open(handle,langdirfile,"w"))==NULL)
	{
		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_ERROR_OPENING_FILE,"nie moge otworzyc pliku: '%s'"),langdirfile);
		if(langdirfile) free(langdirfile);
		return;
	}

   if (fprintf(stream,"%s\n",handle->language.name)<0) DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DATA_SAVING_ERROR,"blad zapisu danych: '%s'"),langdirfile);
	else DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DATA_SAVED,"dane zapisane"));

	if(langdirfile) free(langdirfile);
	fclose(stream);
}

// ***************************************************************************************
// EXTERN                              void com_status(void)
// ***************************************************************************************
void com_status(struct DeniseHandle *handle)
{
	DeniseReport(handle,UNN_GetLocaleString(handle,MSG_SELECTED_LANGUAGE,"aktualny jezyk: %s"),handle->language.name);
	dat_count_odmiany(handle);
}

// ***************************************************************************************
// EXTERN                              void com_about(void)
// ***************************************************************************************
void com_about(struct DeniseHandle *handle)
{
	DeniseReport(handle,"project: Denise-MYTH Artificial Intelligence");
	DeniseReport(handle,"program: Denise 5.1.1 (15.04.2003)");
	DeniseReport(handle,"homepage: http://www.denise.union.pl");
	DeniseReport(handle,"project manager: Szymon Jessa");
	DeniseReport(handle,"other programmers: Piotr Drapich, Stanislaw Szymczyk,");
	DeniseReport(handle,"Piotr Radej, ...");
	DeniseReport(handle,"metodologist: Marek Kasperski");
	DeniseReport(handle,"webmaster: Grzegorz Dziegielewski");
	DeniseReport(handle,"thanks to: dr hab. Andrzej Dyszak (help in polish grammar)");
	DeniseReport(handle,"");
}
// ***************************************************************************************
// EXTERN                              void com_gnu_eng(void)
// ***************************************************************************************
void com_gnu_eng(struct DeniseHandle *handle)
{
}
// ***************************************************************************************
// EXTERN                            void com_gnu_pol(void)
// ***************************************************************************************
void com_gnu_pol(struct DeniseHandle *handle)
{
}
