// ***************************************************************************************
//                                            LOGIC
// ***************************************************************************************

#include "denise.h"
#include "denise_protos.h"

// deklaracje prywatne
static BOOL load_factscmp(struct DeniseHandle* handle);
static BOOL load_conversation(struct DeniseHandle* handle);

// ***************************************************************************************
// EXTERN                    BOOL dat_logic_load(struct DeniseHandle*)
// ***************************************************************************************
BOOL dat_logic_load(struct DeniseHandle* handle)
{
   handle->logic.factscmp=NULL;
   handle->logic.conversation=NULL;

   if (load_factscmp(handle)==TRUE)
	   if (load_conversation(handle)==TRUE)
	      return TRUE;

	return FAIL;
}

static BOOL load_factscmp(struct DeniseHandle* handle)
{
   struct FactsCMPData *fcmp=NULL,*fcmp_last=NULL;
   FILE *stream;
   char temp[200],res[200];
   char *logicdirfile=NULL;

   asprintf(&logicdirfile,"%s%s%s",handle->Prefix,handle->LogicDir,LOGIC_FACTSCMP_FILE);
   if ((stream=dat_file_open(handle,logicdirfile,"r"))==NULL) goto blad;

   // wczytujemy kolejne linie, pomijamy komentarze
   for (;;)
   {
      if (glo_fgets(temp,200,stream)==NULL) break;
      temp[strlen(temp)-1]='\0';

      if (temp[0]==DATABASE_COMMENT) continue;

      fcmp=malloc(sizeof(struct FactsCMPData));
      if (fcmp==NULL) goto blad;
      fcmp->next=NULL;

      glo_get_part(temp,1,res,',');
      fcmp->state=atoi(res);

      glo_get_part(temp,2,res,',');
      fcmp->posnegA=atoi(res);

      glo_get_part(temp,3,res,',');
      fcmp->posnegB=atoi(res);

      glo_get_part(temp,4,res,',');
      fcmp->cmp_res=atoi(res);

      glo_get_part(temp,5,res,',');
      fcmp->new_state=atoi(res);

      glo_get_part(temp,6,res,',');
      fcmp->operation=atoi(res);

      glo_get_part(temp,7,res,',');
      fcmp->groups=atoi(res);

      // dodanie do listy
      if (handle->logic.factscmp==NULL) handle->logic.factscmp=fcmp;
      else fcmp_last->next=fcmp;
      fcmp_last=fcmp;
   }

   fclose(stream);

   if(logicdirfile) free(logicdirfile);
   return TRUE;

   blad:
   if (stream) fclose(stream);
	DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DATA_LOADING_ERROR,"blad odczytu danych: '%s'"),"factscmp.dat");
//   return FAIL;
   if(logicdirfile) free(logicdirfile);
   return TRUE;
}

static BOOL load_conversation(struct DeniseHandle* handle)
{
   FILE *stream;
   struct ConvData *conv,*conv_last=NULL;
	struct
	{
		char code[50]; // opis liczbowy
	   int ile_opisow; // ile dostepnych opisow
		char opis[20][50]; // 20 dopuszczalnych opisow po 50 znakow kazdy
	} trans[100];

   int ile_trans; // ile komend zarejestrowano
   char temp[500],temp1[500],temp2[500],temp3[500],result[500],*ptr;
   //char params[500];
   int nr1,nr2,nr3,ile,line;
   char *logicdirfile=NULL;

	handle->logic.conversation=NULL;

   asprintf(&logicdirfile,"%s%s%s",handle->Prefix,handle->LogicDir,LOGIC_CONVERSATION_FILE);
   if ((stream=dat_file_open(handle,logicdirfile,"r"))==NULL) goto blad;

	line=0;
   // etap 1 - wczytujemy tlumaczenia
   ile_trans=0;

	for (;;)
   {
	   if (glo_fgets(temp,500,stream)==NULL) break;
		line++;
	   temp[strlen(temp)-1]='\0';
      if (strlen(temp)==0) continue;
	   if (temp[0]==DATABASE_COMMENT) continue;
		if (temp[strlen(temp)-1]!=':') break;

      NEW_CODE:;
      ile_trans++;
	   temp[strlen(temp)-1]='\0'; // obcinamy ':'
      strcpy(trans[ile_trans-1].code,temp);
      trans[ile_trans-1].ile_opisow=0;

      for (;;)
      {
	      if (glo_fgets(temp,500,stream)==NULL) break;
			line++;
	      temp[strlen(temp)-1]='\0';
	      if (strlen(temp)==0) continue;
	      if (temp[0]==DATABASE_COMMENT) continue;
			if (temp[strlen(temp)-1]==':') goto NEW_CODE;
         if (temp[0]!='=') goto ETAP2;

         strcpy(trans[ile_trans-1].opis[trans[ile_trans-1].ile_opisow],temp+1);
	      trans[ile_trans-1].ile_opisow++;

//			DeniseReport(handle,"%d=%s",trans[ile_trans-1].code,trans[ile_trans-1].opis[trans[ile_trans-1].ile_opisow-1]);
      }
   }

	for (;;)
   {
	   if (glo_fgets(temp,500,stream)==NULL) break;
		line++;
	   temp[strlen(temp)-1]='\0';
	   if (temp[0]==DATABASE_COMMENT) continue;
      if (strlen(temp)==0) continue;

	   ETAP2:;
//		DeniseReport(handle,"+%s+",temp);

		// w result wynik
      result[0]='\0';

		// do temp1 pobieramy kolejne litery kolejnych wyrazow
		temp1[0]='\0';
      ile=0;
      for (nr1=0;nr1<(int) strlen(temp);nr1++)
      {
      	// jesli to koniec wyrazu...
      	if (temp[nr1]==' ' || temp[nr1]==',' || temp[nr1]=='=' || temp[nr1]==';' || temp[nr1]=='[' || temp[nr1]==']' || temp[nr1]=='(' || temp[nr1]==')' || nr1==(int) strlen(temp)-1 || (temp[nr1]>='0' && temp[nr1]<='9'))
         {
//DeniseReport(handle,"nr: %d",nr1);
				if (nr1<(int) strlen(temp)-1 || temp[nr1]==']' || temp[nr1]==')')
            {
	         	// to przepisujemy znak - ale na koncu!
            }
            else
            {
	         	temp1[ile++]=temp[nr1];
            }

            // i jesli wyraz nie jest pusty, to tlumaczymy wyraz
            if (ile>0)
            {
	         	temp1[ile]='\0';
//DeniseReport(handle,"WYRAZ: :%s:",temp1);

		         for (nr2=0;nr2<ile_trans;nr2++)
		         {
		         	for (nr3=0;nr3<trans[nr2].ile_opisow;nr3++)
		            {
//  	             DeniseReport(handle,"%s=%s+%s",trans[nr2].code,temp1,params);

		            	if (strlen(trans[nr2].opis[nr3])!=strlen(temp1)) continue;
	   	            if (strcmp(trans[nr2].opis[nr3],temp1)!=0) continue;

//DeniseReport(handle,"%s=%s",trans[nr2].code,temp1);
							sprintf(temp2,"%s",trans[nr2].code);
//							strcat(result,trans[nr2].code);
							strcat(result,temp2);
	         	      goto NEXT_PART;
		            }
		         }
					DeniseReport(handle,UNN_GetLocaleString(handle,MSG_INCORRECT_IDENTIFIER,"bledny identyfikator: %s"),temp1);
		         goto blad;
		         NEXT_PART:;
            }

				if (nr1<(int) strlen(temp)-1 || temp[nr1]==']' || temp[nr1]==')')
            {
	         	// przepisujemy znak
					sprintf(temp2,"%c",temp[nr1]);
	            strcat(result,temp2);
//DeniseReport(handle,"!%s!",result);
            }

            temp1[0]='\0';
            ile=0;
         }
         // jesli to znak, ktory mamy pominac, to pomijamy go
			else if (temp[nr1]=='%')
         {
         	// nic nie robimy
         }
         // jesli to czesc wyrazu, to dopisujemy litere
         else
         {
         	temp1[ile++]=temp[nr1];
         }
		}
      strcpy(temp2,result);
//		DeniseReport(handle,"result: !%s!",temp2);

		// zapamietanie + prosta kontrola
      // pierwszym znakiem musi byc CONV_IF
      glo_get_part(temp2,1,temp1,' ');
      if (atoi(temp1)!=CONV_IF)
      {
			DeniseReport(handle,UNN_GetLocaleString(handle,MSG_INCORRECT_LINE,"blad w pliku: %s, w linii %d (%s)"),LOGIC_CONVERSATION_FILE,line,"(if)");
      	goto blad;
      }
      // kasujemy ten znak
		glo_delete_part_sep(handle,temp2,1,' ');

      // pobieramy czesc 1 - CONDITIONS
      sprintf(temp3," %d ",CONV_THEN);
		ptr=strstr(temp2,temp3);
      if (ptr==NULL)
      {
			DeniseReport(handle,UNN_GetLocaleString(handle,MSG_INCORRECT_LINE,"blad w pliku: %s, w linii %d (%s)"),LOGIC_CONVERSATION_FILE,line,"(then)");
         goto blad;
      }

		strcpy(temp1,temp2);
      temp1[strlen(temp2)-strlen(ptr)]='\0'; // w temp1 CONDITIONS
      strcpy(temp2,ptr+strlen(temp3)); // w temp2 ACTION

		// <tu mozna utworzyc dodatkowe punkty kontroli poprawnosci>
      // ...

      // zapamietanie
      conv=malloc(sizeof(struct ConvData));
      if (conv==NULL) goto blad;
      conv->next=NULL;

//printf("COND: '%s', ACT: '%s'\n",temp1,temp2);

      strcpy(conv->conditions,temp1);
      strcpy(conv->action,temp2);

      // dodanie do listy
      if (handle->logic.conversation==NULL) handle->logic.conversation=conv;
      else conv_last->next=conv;
      conv_last=conv;
	}

	fclose(stream);
	if(logicdirfile) free(logicdirfile);
	return TRUE;

   blad:
   if(logicdirfile) free(logicdirfile);
   if (stream) fclose(stream);
	DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DATA_LOADING_ERROR,"blad odczytu danych: '%s'"),LOGIC_CONVERSATION_FILE);
   return TRUE;
}

// ***************************************************************************************
// EXTERN                    BOOL dat_logic_erase(struct DeniseHandle*)
// ***************************************************************************************
BOOL dat_logic_erase(struct DeniseHandle* handle)
{
   struct FactsCMPData *fcmp,*fcmp_next;
   struct ConvData *conv,*conv_next;

   for (fcmp=handle->logic.factscmp;fcmp!=NULL;fcmp=fcmp_next)
   {
      fcmp_next=fcmp->next;
      free(fcmp);
   }
	handle->logic.factscmp=NULL;

//return TRUE;

   for (conv=handle->logic.conversation;conv!=NULL;conv=conv_next)
   {
      conv_next=conv->next;
      if (conv) free(conv);
   }
	handle->logic.conversation=NULL;

   return TRUE;
}
