#ifndef DENISE_H
#define DENISE_H

// commands
#define DENISE_CMD_OFF 0
#define DENISE_CMD_ON 1

#define DENISE_CMD_ABOUT	2
#define DENISE_CMD_HELP		3
#define DENISE_CMD_STATUS	4

// set, get
#define DENISE_CMD_MINWORDS	5
#define DENISE_CMD_MINGROUPS	6
#define DENISE_CMD_MAXGROUPS	7
#define DENISE_CMD_MAXFLEKS	8
#define DENISE_CMD_MAXWORDS	9
#define DENISE_CMD_MAXCLAUSES	10
#define DENISE_CMD_FIRSTCLAUSE	11
#define DENISE_CMD_SUBJECTFIRST	12

#define DENISE_CMD_MINPREFIXLEN	13
#define DENISE_CMD_PREFIXCHECK	14
#define DENISE_CMD_PREFIXCHECKMODE	15
#define DENISE_CMD_REMEMBERFIRST	16

#define DENISE_CMD_PHRASEQUALITY	17
#define DENISE_CMD_STRUCTUREQUALITY	18
#define DENISE_CMD_FUNCTIONQUALITY	19

#define DENISE_CMD_LANGUAGE 20

#define DENISE_CMD_VIEWWORDS 21
#define DENISE_CMD_VIEWCLAUSE 22
#define DENISE_CMD_VIEWSYNTAX 23
#define DENISE_CMD_VIEWSYNTAXTIME 24
#define DENISE_CMD_VIEWPRELIMINARY 25
#define DENISE_CMD_VIEWTHEME 26
#define DENISE_CMD_VIEWINTERLOCUTORY 27
#define DENISE_CMD_VIEWLOGIC 28
#define DENISE_CMD_VIEWFACT 29
#define DENISE_CMD_VIEWUNKNOWNWORDS 30
#define DENISE_CMD_VIEWCONJUNCTIONSANALYSIS 31

#define DENISE_CMD_SUPERVISOR 32

#define DENISE_CMD_LOADCONFIG 33
#define DENISE_CMD_SAVECONFIG 34

#define DENISE_CMD_LOGWORDS 35
#define DENISE_CMD_LOGCLAUSES 36
#define DENISE_CMD_LOGDIALOG 37
#define DENISE_CMD_LOGREPORTS 38

#define DENISE_CMD_ADDWORD 50
#define DENISE_CMD_ADDINFL 51

/* AMIGA, LINUX, WIN32 */

#ifdef WIN32
	#define PC_WIN

	#ifdef __cplusplus
	#define EXPORT extern "C" __declspec (dllexport)
	#else
	#define EXPORT __declspec (dllexport)
	#endif
#else
	#define EXPORT
	#define CALLBACK

//   #undef AMIGA
//   #define LINUX
#endif

#define DENISE_APPNAME "Denise-MYTH"
#define DENISE_AREXXPORT "denise"
#define DENISE_VERSION "5.1 (04.09.2002)"

#define DENISE_VERSION_CHECK "$VERSION=5.1"

// include protos

#include "UNN_System.h"

#include "define.h"
#include "struct.h"
#include "variable.h"

#include "global_protos.h"
#include "command_protos.h"
#include "database_protos.h"
#include "database1_protos.h"
#include "database2_protos.h"
#include "database3_protos.h"
#include "database4_protos.h"
#include "grammar1_protos.h"
#include "grammar2_protos.h"
#include "grammar3_protos.h"
#include "fact_protos.h"
#include "conversation1_protos.h"
#include "logbook_protos.h"
#include "identify1_protos.h"
#include "identify2_protos.h"
#include "extraction_protos.h"
#include "logic1_protos.h"
#include "logic2_protos.h"
#include "logic3_protos.h"
#include "myth_protos.h"
#include "wed_protos.h"

#include "errors.h"
#include "UNN_System_protos.h"
#include "UNN_Locale_protos.h"
#include "UNN_Locale.h"
#include "denise_protos.h"

//#include "sysdeps/DeniseGUI_protos.h"

#ifndef max
#define   max(a,b)    ((a) > (b) ? (a) : (b))
#endif

#ifndef min
#define   min(a,b)    ((a) <= (b) ? (a) : (b))
#endif

#endif
