// ***************************************************************************************
//                                            FACT
// ***************************************************************************************

#include "denise.h"
#include "denise_protos.h"

// ***************************************************************************************
// EXTERN                 void fac_remember_fact(handle,fact)
// ***************************************************************************************
void fac_remember_fact(struct DeniseHandle* handle,struct Fact *fact)
{
   /*
   funkcja zapamietuje fakt w bazie,

   algorytm:
   <wybor bazy danych>
   - sprawdzamy, czy wymagane jest tworzenie nowego tematu,
   - pobieramy kolejne bazy danych,
      - jesli baza nie umozliwia zapisu nowych faktow to pobieramy nastepna,
      - jesli wymagane bedzie tworzenie nowego tematu, a baza nie umozliwia tego, to pobieramy nastepna,
      - pobieramy kolejne tematy,
         - sprawdzamy, czy jakis fakt prosty odwoluje sie do tego tematu,
           badz do tematu, na ktory ten temat jest przekierowywany,
           i jesli TAK, to zapamietujemy te baze i zliczamy liczbe odwolan,
   - wybieramy baze z listy, z najwieksza liczba odwolan, a jesli nie ma takiej,
     to odszukujemy baze dowolna, umozliwiajaca:
      - zapis nowych faktow,
      - jesli sa nowe tematy to zapis tematow,
      jesli nie ma takiej bazy, to tworzymy nowa,
   <dodanie faktu do bazy>
   - pobieramy kolejne fakty proste,
      - jesli theme_number>0 to sprawdzamy, czy mozna dodac identyfikatory do
        tematu (ktory nie ma forwardu juz <- ten ostateczny), i dodajemy,
        probujac wskazac na temat w aktualnej bazie, jesli taki temat istnieje
        (moze byc z forwardem na temat ostateczny), ustawiamy prepare=TRUE
      - jesli theme_number==0 to tworzymy nowy temat, opierajac sie na
        identyfikatorach nadrzednych (podmiotowych) faktu prostego,
        i przypisujemy faktowi numer powstalego tematu,
        nastepnie sprawdzamy, czy jakis kolejny fakt prosty,
        ktory nie ma tematu, ma te same identyfikatory, i jesli tak, to podajemy
        w nim informacje o utworzonym temacie,
      - jesli theme_number<0 to blad,
   - jesli dodalismy jakies nowe identyfikatory (prepare==TRUE), to musimy przygotowac
     bazy do pracy, gdyz moglo sie okazac, ze powstaly temat jest identyczny
     z jakims juz istniejacym (tzn. oba tematy okazaly sie tymi samymi),
     jesli tak, to dokonujemy forwardu itd.
   - jesli nie ma tematu Denise, to probujemy odszukac,
   - jesli jakis fs jest ma nowy temat rozmowcy, to przypisujemy temat rozmowcy tematowi temu fs,
   */

   FILE *stream=NULL;
   struct FactDatabase *data;
   struct Theme *theme,*theme_fwd,*theme1;
   struct Fact *fact_last;
   struct FactSimple *fs,*fs1;
   BOOL new_theme=FALSE; // czy fakt posiada zupelnie nowy temat
   BOOL prepare=FALSE;
   struct
   {
      struct FactDatabase *baza;
      int ile;
   } odwolania[100];
   int ile_odwolan=0,nr1,nr2;
   char temp1[1000];

   // <wybor bazy danych>
   // sprawdzamy, czy wymagane jest tworzenie nowego tematu,
   for (fs=fact->fs;fs!=NULL;fs=fs->next)
   {
      if (fs->theme_number==0) new_theme=TRUE;
      // jesli theme_number<0 to blad,
      else if (fs->theme_number<0)
      {
         printf("kataaaaastrofa w fac_remember_fact\n");
         return;
      }
   }

   // pobieramy kolejne bazy danych,
   for (data=handle->facts;data!=NULL;data=data->next)
   {
      // jesli baza nie umozliwia zapisu nowych faktow to pobieramy nastepna,
      if (data->new_facts!=1) continue;
      // jesli wymagane bedzie tworzenie nowego tematu, a baza nie umozliwia tego, to pobieramy nastepna,
      if (new_theme==TRUE && data->new_themes!=1) continue;

      // pobieramy kolejne tematy,
      for (theme=data->themes;theme!=NULL;theme=theme->next)
      {
         if (theme->fwd_databaseID[0]=='\0') theme_fwd=theme;
         else
         {
            theme_fwd=ide_find_theme(handle,theme->fwd_databaseID,theme->fwd_number);
            if (theme_fwd==NULL)
            {
               DeniseReport(handle,"blad! nie odnaleziono tematu: fac_remember_fact");
               return;
            }
         }

         // sprawdzamy, czy jakis fakt prosty odwoluje sie do tego tematu,
         // badz do tematu, na ktory ten temat jest przekierowywany,
         for (fs=fact->fs;fs!=NULL;fs=fs->next)
         {
            if (fs->theme_number==0) continue;

            if ((theme1=ide_find_theme(handle,fs->databaseID,fs->theme_number))==NULL)
            {
               printf("blad fatotalny w fac_remember_fact!\n");
               return;
            }

            // i jesli TAK, to zapamietujemy te baze i zliczamy liczbe odwolan,
            if (theme1!=theme_fwd) continue;

            for (nr1=0,nr2=-1;nr1<ile_odwolan;nr1++)
               if (odwolania[nr1].baza==data)
               {
                  nr2=nr1;
                  break;
               }

            // jesli to pierwszy zapis tej bazy to wpisujemy ja
            if (nr2==-1)
            {
               odwolania[ile_odwolan].baza=data;
               odwolania[ile_odwolan].ile=1;
               ile_odwolan++;
            }
            else odwolania[nr2].ile++;
         }
      }
   }

   // wybieramy baze z listy, z najwieksza liczba odwolan,
   data=NULL;
   if (ile_odwolan>0)
   {
      nr2=0;
      for (nr1=0;nr1<ile_odwolan;nr1++)
      {
         if (data==NULL || odwolania[nr1].ile>nr2)
         {
            data=odwolania[nr1].baza;
            nr2=odwolania[nr1].ile;
         }
      }
   }
   // a jesli nie ma takiej,
   else
   {
      // to odszukujemy baze dowolna, umozliwiajaca:
      for (data=handle->facts;data!=NULL;data=data->next)
      {
         // zapis nowych faktow,
         if (data->new_facts!=1) continue;
         // jesli sa nowe tematy to zapis tematow,
         if (new_theme==TRUE && data->new_themes!=1) continue;
         break;
      }
      // jesli nie ma takiej bazy, to tworzymy nowa,
      if (data==NULL)
      {
         data=malloc(sizeof(struct FactDatabase));
			if (data==NULL)
			{
printf("fact.c ERROR 1\n");
return;
			}
         data->next=NULL;
         data->themes=NULL;
         data->facts=NULL;
         data->name=NULL;
         data->mode_name1=NULL;
         data->mode_name2=NULL;
         data->mode_name3=NULL;
         data->new_facts=1;
         data->new_themes=1;
         data->fwd_themes=1;

         glo_current_time(temp1,1);
         strcpy(data->databaseID,temp1);

         data->name=malloc(strlen(temp1)+1);
			if (data->name==NULL)
			{
printf("fact.c ERROR 2\n");
return;
			}
         memcpy(data->name,temp1,strlen(temp1)+1);

         // dodajemy ja do calkowitej bazy danych
         if (handle->facts==NULL) handle->facts=data;
         else
         {
            data->next=handle->facts->next;
            handle->facts->next=data;
         }

         // wpisujemy do pliku informacje o nowej bazie
         if ((stream=dat_file_open(handle,FACTS_DIR FACTS_LIST_FILE,"a"))==NULL) return;
         fprintf(stream,"%s\n",data->name);
         fclose(stream);
			DeniseReport(handle,UNN_GetLocaleString(handle,MSG_NEW_FACTS_DATABASE,"utworzono nawa baze faktow: '%s'"),data->name);
      }
   }

   if (data==NULL)
   {
      printf("fatalnosc fatalow totalow bledow 1 w fac_remember_fact\n");
      return;
   }

   // <dodanie faktu do bazy>
   // pobieramy kolejne fakty proste,
   for (fs=fact->fs;fs!=NULL;fs=fs->next)
   {
      // jesli theme_number>0 to
      if (fs->theme_number>0)
      {
         // sprawdzamy, czy mozna dodac identyfikatory do
         // tematu (ktory nie ma forwardu juz <- ten ostateczny), i dodajemy,
         theme_fwd=ide_find_theme(handle,fs->databaseID,fs->theme_number);
         if (theme_fwd==NULL)
         {
            printf("niezapooooominajka bledna nr X w fac_remember_fact\n");
            return;
         }

         strcpy(temp1,fs->sentence->id_subject);
         ide_optimize_identifiers(handle,temp1);
         ide_add_identifiers(handle,theme_fwd,temp1);

         // wstepnie ustalamy temat fs na ostateczny
         strcpy(fs->databaseID,theme_fwd->database->databaseID);
         fs->theme_number=theme_fwd->number;

         // probujemy wskazac na temat w aktualnej bazie (moze byc z forwardem na temat ostateczny),
         // jesli taki temat istnieje
         for (theme=data->themes;theme!=NULL;theme=theme->next)
         {
            if (theme->fwd_databaseID[0]=='\0') continue;
            if (ide_find_theme(handle,theme->fwd_databaseID,theme->fwd_number)!=theme_fwd) continue;

            strcpy(fs->databaseID,theme->database->databaseID);
            fs->theme_number=theme->number;
            break;
         }

         prepare=TRUE;
      }
      // jesli theme_number==0 to
      else
      {
         // tworzymy nowy temat, operajac sie na
         // identyfikatorach nadrzednych (glownych, podmiotowych) faktu prostego,
         // i przypisujemy faktowi numer powstalego tematu,
         theme=malloc(sizeof(struct Theme));
			if (theme==NULL)
			{
printf("fact ERROR 3\n");
return;
			}
         theme->next=NULL;
         theme->identify=NULL;
         theme->database=data;
         theme->number=ide_free_theme_number(handle,data);
         theme->fwd_databaseID[0]='\0';
         theme->fwd_number=0;

         strcpy(fs->databaseID,data->databaseID);
         fs->theme_number=theme->number;

         strcpy(temp1,fs->sentence->id_subject);
         ide_optimize_identifiers(handle,temp1);
         theme->identify=malloc(strlen(temp1)+1);
			if (theme->identify==NULL)
			{
printf("fact ERROR 4\n");
return;
			}
         strcpy(theme->identify,temp1);

         if (data->themes==NULL) data->themes=theme;
         else
         {
            for (theme1=data->themes;theme1->next!=NULL;theme1=theme1->next);
            theme1->next=theme;
         }
         theme=NULL; // jest porzadek

         // nastepnie sprawdzamy, czy jakis kolejny fakt prosty,
         for (fs1=fs->next;fs1!=NULL;fs1=fs1->next)
         {
            // ktory nie ma tematu,
            if (fs1->theme_number==0)
            {
               // ma te same identyfikatory, i jesli tak,
               if (strcmp(fs1->sentence->id_subject,fs->sentence->id_subject)==0)
               {
                  // to podajemy w nim informacje o utworzonym temacie,
                  strcpy(fs1->databaseID,fs->databaseID);
                  fs1->theme_number=fs->theme_number;
               }
            }
         }
      }
   }

   // dopisujemy fakt na koncu bazy,
   if (data->facts==NULL) data->facts=fact;
   else
   {
      for (fact_last=data->facts;fact_last->next!=NULL;fact_last=fact_last->next);
      fact_last->next=fact;
   }

   if (prepare==TRUE)
   {
      // jesli dodalismy jakies nowe identyfikatory, to musimy przygotowac
      // bazy do pracy, gdyz moglo sie okazac, ze powstaly temat jest identyczny
      // z jakims juz istniejacym (tzn. oba tematy okazaly sie tymi samymi),
      // jesli tak, to dokonujemy forwardu itd.
      fac_prepare_databases(handle);
      nr1=ext_set_denise_theme(handle);
      if (nr1>1)
      {
			DeniseReport(handle,UNN_GetLocaleString(handle,MSG_TOO_MUCH_DENISE_THEMES,"odnaleziono zbyt wiele tematow DENISE"));
			DeniseReport(handle,UNN_GetLocaleString(handle,MSG_ERASING_FACTS_DATABASES,"kasuje z pamieci bazy faktow"));
         dat_facts_erase(handle);
      }
   }
   else if (handle->cache.denise==NULL)
   {
      // odszukanie informacji o osobowosci Denise
      nr1=ext_set_denise_theme(handle);
      if (nr1==1) DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DENISE_THEME_FOUNDED,"odnaleziono temat DENISE"));
      else if (nr1>1)
      {
			DeniseReport(handle,UNN_GetLocaleString(handle,MSG_TOO_MUCH_DENISE_THEMES,"odnaleziono zbyt wiele tematow DENISE"));
			DeniseReport(handle,UNN_GetLocaleString(handle,MSG_ERASING_FACTS_DATABASES,"kasuje z pamieci bazy faktow"));
         dat_facts_erase(handle);
      }
   }

   // jesli jakis fs jest ma nowy temat rozmowcy, to przypisujemy temat rozmowcy tematowi temu fs,
   for (fs=fact->fs;fs!=NULL;fs=fs->next)
   {
      if (ext_get_person(handle,fs->sentence)!=1) continue;
      if ((theme=ide_find_theme(handle,fs->databaseID,fs->theme_number))==NULL) continue;
      handle->cache.user=theme;
   }
}
// ***************************************************************************************
// EXTERN         struct FactSimple *fac_get_fs(struct Fact *fact,int nr)
// ***************************************************************************************
struct FactSimple *fac_get_fs(struct Fact *fact,int nr)
{
   struct FactSimple *fs;
   int nr1;

   nr--; // zaczynamy liczebnie fs od liczby 1

   for (nr1=0,fs=fact->fs;nr1<nr && fs!=NULL;nr1++,fs=fs->next);

   if (nr1!=nr) return NULL;
   return fs;
}

// ***************************************************************************************
// EXTERN          int fac_count_fs_in_database(struct FactDatabase *database)
// ***************************************************************************************
int fac_count_fs_in_database(struct FactDatabase *database)
{
   struct Fact *fact;
   int nr1=0;

   for (fact=database->facts;fact!=NULL;fact=fact->next)
      nr1=nr1+fac_count_fs(fact);

   return nr1;
}

// ***************************************************************************************
// EXTERN                   int fac_count_fs(struct Fact *fact)
// ***************************************************************************************
int fac_count_fs(struct Fact *fact)
{
   struct FactSimple *fs;
   int nr1=0;

   for (fs=fact->fs;fs!=NULL;fs=fs->next) nr1++;

   return nr1;
}
// ***************************************************************************************
// EXTERN         BOOL fac_exist_unknown_fs(DeniseHandle*handle,Fact *fact)
// ***************************************************************************************
BOOL fac_exist_unknown_fs(struct DeniseHandle* handle,struct Fact *fact)
{
   int cmpres;
   struct FactDatabase *facts;
   struct Fact *fact1;
   struct FactSimple *fsA,*fsB;

   if (fact==NULL) return FALSE;

   for (fsA=fact->fs;fsA!=NULL;fsA=fsA->next)
   {
      if (fsA->theme_number==0) return TRUE;

      for (facts=handle->facts;facts!=NULL;facts=facts->next)
      {
         for (fact1=facts->facts;fact1!=NULL;fact1=fact1->next)
         {
            for (fsB=fact1->fs;fsB!=NULL;fsB=fsB->next)
            {
               cmpres=log_fscmp(handle,fsA,fsB,CMP_ALL_GROUPS);
               if (cmpres==FCMP_A_EQU_B || cmpres==FCMP_A_IN_B) goto NEXT_FS;
            }
         }
      }
      return TRUE; // nieznany fakt prosty
      NEXT_FS:;
   }

   return FALSE; // nie ma zadnego nieznanego faktu prostego
}

// ***************************************************************************************
// EXTERN                 fac_prepare_databases(DeniseHandle*handle)
// ***************************************************************************************
void fac_prepare_databases(struct DeniseHandle* handle)
{
   /*
   funkcja przygotowuje wczytane bazy danych do pracy (organizuje je ze soba),
   zadania funkcji:
   - ujednolicenie wskazan na tematy dublujace sie w bazach,
   - kontrola obecnosci wszystkich tematow wymaganych przez fakty proste,

   algorytm:
   - zerujemy wszystkie forwardy,

   <eliminacja dublujacych sie tematow>
   - dla kolejnych baz danych pobieramy kolejne tematy A,
      - dla tej i nastepnych baz danych pobieramy kolejne tematy B,
         - porownujemy temat A i temat B:
            - jesli sa identyczne, to sprawdzamy, czy mozna jeden przekierowac:
               - jesli nie mozna to w ogole rezygnujemy z jednej bazy danych (mniejszej),
                 oraz informujemy o takiej sytuacji (w szczegolach),
               - jesli mozna, to przekierowujemy
            - jesli sa rozne, to dalej,

   <kontrola tematow faktow prostych>
   - pobieramy kolejne fakty proste z wszystkich baz faktow,
      - sprawdzamy, czy temat faktu jest dostepny:
         - jesli nie, to kasujemy cala baze, do ktorej nalezy fakt prosty,
         - jesli tak, to nastepny fakt prosty
   */

   struct FactDatabase *data1,*data2,*data1_last=NULL,*data2_last=NULL;
   struct Theme *themeA,*themeB;
   struct Fact *fact;
   struct FactSimple *fs;
   char temp1[100];
   int nr1,nr2,result;

   // kasujemy dotychczasowe forwardowania
   for (data1=handle->facts;data1!=NULL;data1_last=data1,data1=data1->next)
   {
      for (themeA=data1->themes;themeA!=NULL;themeA=themeA->next)
      {
         themeA->fwd_databaseID[0]='\0';
         themeA->fwd_number=0;
      }
   }

   // <eliminacja dublujacych sie tematow>
   START:
   if (handle->facts!=NULL)
   {
      // dla kolejnych baz danych pobieramy kolejne tematy A,
      for (data1=handle->facts;data1!=NULL;data1_last=data1,data1=data1->next)
      {
         for (themeA=data1->themes;themeA!=NULL;themeA=themeA->next)
         {
            if (themeA->fwd_databaseID[0]!='\0') continue;

            // dla nastepnych baz danych pobieramy kolejne tematy B,
            for (data2=data1;data2!=NULL;data2_last=data2,data2=data2->next)
            {
               for (themeB=data2->themes;themeB!=NULL;themeB=themeB->next)
               {
                  if (themeB->fwd_databaseID[0]!='\0') continue;

                  // pomijamy porownanie tematu z samym soba
                  if (themeA==themeB) continue;

                  // porownujemy temat A i temat B:
                  // jesli sa identyczne, to sprawdzamy, czy mozna jeden przekierowac:
                  result=ide_cmp_themes(handle,themeA,themeB,MODE_EXACT);
                  if (result==FCMP_A_EQU_B)
                  {
//printf("%s=%s (%d)\n",themeA->identify,themeB->identify,result);
                     // jesli nie mozna to w ogole rezygnujemy z jednej bazy danych (mniejszej),
                     // oraz informujemy o takiej sytuacji (w szczegolach),
                     if (data2->fwd_themes!=1 && data1->fwd_themes!=1)
                     {
								DeniseReport(handle,UNN_GetLocaleString(handle,MSG_THEME_FORWARDING_EXPECTED,"wymagane przekierowanie tematu w bazach: %s i %s"),data1->name,data2->name);
								DeniseReport(handle,UNN_GetLocaleString(handle,MSG_NO_THEMES_FORWARDING,"baza zabrania dokonania przekierowania"));
                        if (fac_count_fs_in_database(data1)<fac_count_fs_in_database(data2))
                        {
									DeniseReport(handle,UNN_GetLocaleString(handle,MSG_ERASING_FACTS_DATABASE,"kasuje jedna baze faktow: %s"),data1->name);
                           if (data1==handle->facts) handle->facts=data1->next;
                           else data1_last->next=data1->next;
                           dat_database_free(data1);
									free(data1);
                           goto START;
                        }
                        else
                        {
									DeniseReport(handle,UNN_GetLocaleString(handle,MSG_ERASING_FACTS_DATABASE,"kasuje jedna baze faktow: %s"),data2->name);
                           data2_last->next=data2->next;
                           dat_database_free(data2);
									free(data2);
                           goto START;
                        }
                     }
                     else
                     {
                        // jesli mozna przekierowac obie, to przekierowujemy do starszej, a jak nie to tam gdzie mozna,
                        if (data1==data2)
                        {
                           strcpy(themeB->fwd_databaseID,data1->databaseID);
                           themeB->fwd_number=themeA->number;
                           goto NEXT_THEMEB;
                        }
                        else
                        {
                           for (nr1=0,nr2=strlen(data1->databaseID);nr1<nr2;nr1++)
                           {
                              if (data1->databaseID[nr1]==data2->databaseID[nr1]) continue;
                              else if (data1->databaseID[nr1]<data2->databaseID[nr1] || data1->fwd_themes!=1)
                              {
                                 strcpy(themeB->fwd_databaseID,data1->databaseID);
                                 themeB->fwd_number=themeA->number;
                                 goto NEXT_THEMEB;
                              }
                              else if (data1->databaseID[nr1]>data2->databaseID[nr1] || data2->fwd_themes!=1)
                              {
                                 strcpy(themeA->fwd_databaseID,data2->databaseID);
                                 themeA->fwd_number=themeB->number;
                                 goto NEXT_THEMEB;
                              }
                           }
                        }
                        // jesli nie dalo sie przekierowac, to informujemy o bledzie
                        // i rezygnujemy z jednej bazy danych (mniejszej),
								DeniseReport(handle,UNN_GetLocaleString(handle,MSG_THEME_FORWARDING_FAILED,"przekierowanie w bazach: %s i %s nie powiodlo sie"),data1->name,data2->name);
                        if (fac_count_fs_in_database(data1)<fac_count_fs_in_database(data2))
                        {
									DeniseReport(handle,UNN_GetLocaleString(handle,MSG_ERASING_FACTS_DATABASE,"kasuje jedna baze faktow: %s"),data1->name);
                           if (data1==handle->facts) handle->facts=data1->next;
                           else data1_last->next=data1->next;
                           dat_database_free(data1);
									free(data1);
                           goto START;
                        }
                        else
                        {
									DeniseReport(handle,UNN_GetLocaleString(handle,MSG_ERASING_FACTS_DATABASE,"kasuje jedna baze faktow: %s"),data2->name);
                           if (data2==handle->facts) handle->facts=data2->next;
                           else data2_last->next=data2->next;
                           dat_database_free(data2);
                           free(data2);
                           goto START;
                        }
                     }
                  }
                  // jesli sa rozne, to dalej,
                  NEXT_THEMEB:;
               }
            }
         }
      }
   }

   // <kontrola tematow faktow prostych>
   // pobieramy kolejne fakty proste z wszystkich baz faktow,
   START2:
   for (data1=handle->facts;data1!=NULL;data1_last=data1,data1=data1->next)
   {
      for (fact=data1->facts;fact!=NULL;fact=fact->next)
      {
         for (fs=fact->fs;fs!=NULL;fs=fs->next)
         {
            // sprawdzamy, czy temat faktu jest dostepny:
            // jesli nie, to kasujemy cala baze, do ktorej nalezy fakt prosty,
            if (ide_find_theme(handle,fs->databaseID,fs->theme_number)==NULL)
            {
               ide_filter_identifiers(handle,fs->sentence->id_subject,temp1,1);
					DeniseReport(handle,UNN_GetLocaleString(handle,MSG_THEME_NOT_FOUND,"nie odnaleziono tematu: '%s'"),temp1);
					DeniseReport(handle,UNN_GetLocaleString(handle,MSG_ERASING_FACTS_DATABASE,"kasuje jedna baze faktow: %s"),data1->name);

               if (data1==handle->facts) handle->facts=data1->next;
               else data1_last->next=data1->next;
               dat_database_free(data1);
               free(data1);
               goto START2;
            }
            // jesli tak, to nastepny fakt prosty
         }
      }
   }
}
