// ***************************************************************************************
//                                            LOGBOOK
// ***************************************************************************************

#include "denise.h"
#include "denise_protos.h"

// ***************************************************************************************
// EXTERN                 void log_unknown_word(handle,wyraz)
// ***************************************************************************************
void log_unknown_word(struct DeniseHandle* handle,char *wyraz)
{
	FILE *stream;
	char *logbookdirfile=NULL;

	if (handle->viewparams.unknown_words==ON) DeniseReport(handle,UNN_GetLocaleString(handle,MSG_UNKNOWN_WORD,"nieznane slowo: %s"),wyraz);
   if (handle->logbookparams.words==OFF) return;
   asprintf(&logbookdirfile,"%s%s%s",handle->Prefix,handle->LogbookDir,LOGBOOK_WORDS_FILE);
   if ((stream=fopen(logbookdirfile,"a"))==NULL) return;
 	fprintf(stream,"%s\n",wyraz);
 	fclose(stream);
   if(logbookdirfile) free(logbookdirfile);
}

// ***************************************************************************************
// EXTERN                 void log_unknown_clause(handle,clause)
// ***************************************************************************************
void log_unknown_clause(struct DeniseHandle* handle,char *clause)
{
	FILE *stream;
	char *logbookdirfile=NULL;

   asprintf(&logbookdirfile,"%s%s%s",handle->Prefix,handle->LogbookDir,LOGBOOK_CLAUSES_FILE);
   if ((stream=fopen(logbookdirfile,"a"))==NULL) return;
  	fprintf(stream,"%s\n",clause);
 	fclose(stream);
   if(logbookdirfile) free(logbookdirfile);
}

// ***************************************************************************************
// EXTERN                 void log_dialog(handle,message)
// ***************************************************************************************
void log_dialog(struct DeniseHandle* handle,char *message)
{
	FILE *stream;
	char *logbookdirfile=NULL;

   asprintf(&logbookdirfile,"%s%s%s",handle->Prefix,handle->LogbookDir,LOGBOOK_DIALOG_FILE);
   if ((stream=fopen(logbookdirfile,"a"))==NULL) return;
  	fprintf(stream,"%s\n",message);
 	fclose(stream);
   if(logbookdirfile) free(logbookdirfile);
}

// ***************************************************************************************
// EXTERN                 void log_reports(handle,message)
// ***************************************************************************************
void log_reports(struct DeniseHandle* handle,char *message)
{
	FILE *stream;
	char *logbookdirfile=NULL;

   asprintf(&logbookdirfile,"%s%s%s",handle->Prefix,handle->LogbookDir,LOGBOOK_REPORTS_FILE);
   if ((stream=fopen(logbookdirfile,"a"))==NULL) return;
  	fprintf(stream,"%s\n",message);
 	fclose(stream);
   if(logbookdirfile) free(logbookdirfile);
}

