/*
wszyscy maja samochod
michal ma rower lub michal ma samochod


sprawdzic



michal ma rower?
*/
// ***************************************************************************************
//                                         LOGIC - MAIN
// ***************************************************************************************

#include "denise.h"
#include "denise_protos.h"

// deklaracje prywatne
static BOOL deductive_data_check(struct DeniseHandle* handle,struct LogicClause *head);
static BOOL resolution(struct DeniseHandle* handle,struct LogicClause *clause1,struct LogicClause *clause2,struct LogicClause *result);
static void clause_optimize(struct DeniseHandle *handle,struct LogicClause *clause);
static void join_clauses(struct DeniseHandle* handle,struct LogicClause *clause1,char *opis1,struct LogicClause *clause2,char *opis2,struct LogicClause *result);
static int add_clauses(struct DeniseHandle *handle,struct LogicClause **head,char *nowy,struct Fact *fact,int type);
static int copy_clauses(struct DeniseHandle *handle,struct LogicClause **head,char *nowy,struct LogicClause *src,int type);
static void del_clauses(struct LogicClause **head,int ile);
static void fact_pack(struct Fact *fact,char *result);
static int database2clause(struct DeniseHandle *handle,struct LogicClause **dst);
static int cmp_groups(struct DeniseHandle *handle,char *podstA,char *fleksA,char *podstB,char *fleksB);
static void kasuj_spojnik_and(struct DeniseHandle *handle,char *podst,char *fleks);
static void get_group_without_neg(struct DeniseHandle *handle,struct FactSimple *fs,int nr_grupy,char *result,char *res_fleks);
static int count_logic_facts(char *expr);
static int count_clauses(struct LogicClause *head);

// ***************************************************************************************
// EXTERN       int logic_analysis(struct DeniseHandle* handle,struct Fact *fact)
// ***************************************************************************************
struct LogicAnalysis logic_analysis(struct DeniseHandle* handle,struct Fact *fact)
{
   /*
   funkcja zwraca strukture LogicAnalysis:
   deduce - lista klauzul wykorzystanych do wnioskowania,
   logic_state - wynik logiczny wnioskowania: LOGIC_TRUE, LOGIC_FALSE,
   neg - negacja: TRUE - fakt zanegowany, FALSE - fakt zgodny (lub brak danych),

   logiczne sprawdzanie faktu (jego klauzul):
   - tworzymy tablice klauzul z listy tematow w pamieci podrecznej,
   - laczymy wszystkie klauzule badanego faktu spojnikiem AND, dodajac nawiasy,
   - zanegowany fakt badany przeksztalcamy do postaci klauzul i dopisujemy do tablicy klauzul,
   - jesli baza jest sprzeczna to UDOWODNIONO PRAWDZIWOSC FAKTU,
   - jesli baza nie jest sprzeczna, to:
      - fakt badany przeksztalcamy do postaci klauzul i dopisujemy do listy klauzul,
      - jesli baza jest sprzeczna to UDOWODNIONO FALSZYWOSC FAKTU,
      - jesli baza nie jest sprzeczna, to UDOWODNIONO BRAK DANYCH,

   UWAGA! klauzule hipotezy dopisywane sa na poczatku, co przyspiesza znajdowanie sprzecznosci,
   */

   struct LogicAnalysis result;
   struct LogicClause *clauses_head=NULL; // lista klauzul
   int fact_clauses;
   char temp1[1000],temp2[1000];

   // wstepne ustalenie rezultatu
   result.deduce=NULL;
   result.logic_state=LOGIC_FALSE;
   result.neg=FALSE;

   // utworzenie tablicy klauzul z wszystkich baz danych
   if (database2clause(handle,&clauses_head)==0) return result;

   // zabezpieczenie
   if (fact->ile_klauzul==0)
   {
	   DeniseMessage(handle,"blad! analizowany fakt nie posiada klauzul! (logic1.c)");
		return result;
   }

   // laczymy wszystkie klauzule badanego faktu spojnikiem AND, dodajac nawiasy,
   fact_pack(fact,temp1);

   // negujemy fakt
   sprintf(temp2,"%d(%s)",CON_NOT,temp1);

   // zanegowany fakt badany przeksztalcamy do postaci klauzul (oddzielone przecinkiem)
//DeniseMessage(handle,"1: %s, klauzul: %d",temp2,fact->ile_klauzul);
   log_expr2clause(handle,temp2,temp1);
   if (strlen(temp1)==0)
   {
		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_NO_CLAUSES,"brak klauzul"));
      log_clauses_free(&clauses_head);
      return result;
   }

   // dopisujemy fakt (hipoteze) w postaci klauzul do listy klauzul,
   if ((fact_clauses=add_clauses(handle,&clauses_head,temp1,fact,IS_HYPOTHESIS))==-1)
   {
      log_clauses_free(&clauses_head);
      return result;
   }

   // jesli baza jest sprzeczna to UDOWODNIONO PRAWDZIWOSC FAKTU,
   if (deductive_data_check(handle,clauses_head)==FALSE)
   {
      if (handle->viewparams.logic_analysis==ON)
  		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_NUMBER_OF_CLAUSES_USED,"wykorzystano %d klauzul"),count_clauses(clauses_head));
      result.logic_state=LOGIC_TRUE;
      result.neg=FALSE;
      result.deduce=clauses_head;
      return result;
   }
   // jesli baza nie jest sprzeczna, to:
   else
   {
      // usuwamy dodane klauzule zanegowanego faktu i utworzone z wnioskowania
//      del_clauses(&clauses_head,fact_clauses);

      log_clauses_free(&clauses_head);
//      clauses_head=NULL;
      database2clause(handle,&clauses_head);

      // fakt badany przeksztalcamy do postaci klauzul i dopisujemy do listy klauzul,
      // laczymy wszystkie klauzule badanego faktu spojnikiem AND, dodajac nawiasy,
      fact_pack(fact,temp2);

      // fakt badany przeksztalcamy do postaci klauzul (oddzielone przecinkiem)
//DeniseMessage(handle,"2: %s",temp2);
      log_expr2clause(handle,temp2,temp1);
      if (strlen(temp1)==0)
      {
	  		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_NO_CLAUSES,"brak klauzul"));
         log_clauses_free(&clauses_head);
         return result;
      }

      // dopisujemy fakt (hipoteze) w postaci klauzul do listy klauzul,
      if ((fact_clauses=add_clauses(handle,&clauses_head,temp1,fact,IS_HYPOTHESIS))==-1)
      {
         log_clauses_free(&clauses_head);
         return result;
      }

      // jesli baza jest sprzeczna to UDOWODNIONO FALSZYWOSC FAKTU,
      if (deductive_data_check(handle,clauses_head)==FALSE)
      {
         if (handle->viewparams.logic_analysis==ON) DeniseReport(handle,UNN_GetLocaleString(handle,MSG_NUMBER_OF_CLAUSES_USED,"wykorzystano %d klauzul"),count_clauses(clauses_head));
         result.logic_state=LOGIC_FALSE;
         result.neg=TRUE;
         result.deduce=clauses_head;
         return result;
      }
      // jesli baza nie jest sprzeczna, to UDOWODNIONO BRAK DANYCH,
      else
      {
         if (handle->viewparams.logic_analysis==ON) DeniseReport(handle,UNN_GetLocaleString(handle,MSG_NUMBER_OF_CLAUSES_USED,"wykorzystano %d klauzul"),count_clauses(clauses_head));
         result.deduce=NULL;
         result.logic_state=LOGIC_FALSE;
         result.neg=FALSE;
         return result;
      }
   }

   // praktycznie program nie powinien nigdy sie tu znalezc!
   printf("a to cholerstwo no w logic1.c\n");

   // zwolnienie pamieci zajmowanej przez klauzule
   log_clauses_free(&clauses_head);
   return result;
}

static BOOL deductive_data_check(struct DeniseHandle* handle,struct LogicClause *head)
{
   /*
   funkcja kontroluje liste klauzul (HEAD), czy nie zachodzi wewnetrzna sprzecznosc danych,
   korzysta przy tym z metody rezolucji,

   funkcja zwraca:
   TRUE - jesli w klauzulach nie wykryto sprzecznosci,
   FALSE - jesli wykryto sprzecznosc,

   ustalamy cmp_start na head->next
   START:
   - ustalamy cmp_end na ostatnia klauzule na liscie head,
   - pobieramy kolejne clauseA od klauzuli head (wlacznie) a konczac na cmp_end (wlacznie)
      - pobieramy kolejne clauseB od cmp_start a konczac na cmp_end (wlacznie)
      - stosujemy metode rezolucji dla clauseA i clauseB:
         - jesli nie udalo sie zastosowac metody to dalej,
         - jesli w wyniku powstala klauzula pusta NULL to zwracamy RETURN FALSE,
         - jesli w wyniku powstala nowa klauzula to:
            - sprawdzamy, czy ta klauzula juz jest na liscie, a jesli nie, to
              dopisujemy ja w czesci przewidzianej dla nowych klauzul (od cmp_end),
   - po pobraniu wszystkich klauzul, sprawdzamy, czy sa jakies nowe
     (tj. czy cmp_end->next jest rozne od NULL), jesli sa nowe, to ustawiamy
     cmp_start na cmp_end->next, i skaczemy na START,

   algorytm gwarantuje, ze kazda nowa klauzula zostanie porownana z wszystkimi
   */

   struct LogicClause *cmp_start,*cmp_end,*clauseA,*clauseB,clause_res,*clause;
   BOOL resolution_res,exist;
   int nr1;

int p1,p2;
char chwila[1000];

   if (head==NULL) return TRUE;
   else if (head->next==NULL) return TRUE;

   // ustalamy cmp_start na head->next
   cmp_start=head->next;
   cmp_end=cmp_start;

   START:
   // ustalamy cmp_end na ostatnia klauzule na liscie head,
   if (cmp_end!=NULL)
      if (cmp_end->next!=NULL)
         for (;cmp_end->next!=NULL;cmp_end=cmp_end->next);

   // pobieramy kolejne clauseA od klauzuli head (wlacznie) a konczac na cmp_end (wylaczajac)
   for (clauseA=head;clauseA!=cmp_end;clauseA=clauseA->next)
   {
      // pobieramy kolejne clauseB od cmp_start a konczac na cmp_end (wlacznie)
      for (clauseB=cmp_start;clauseB!=cmp_end->next;clauseB=clauseB->next)
      {
         // stosujemy metode rezolucji dla clauseA i clauseB:
         resolution_res=resolution(handle,clauseA,clauseB,&clause_res);

//DeniseMessage(handle,"resolution result: %s z %s+%s=%s\n",resolution_res==TRUE ? "TRUE" : "FALSE",clauseA->fs[0]->sentence->base_words,clauseB->fs[0]->sentence->base_words,clause_res.opis);

         // jesli nie udalo sie zastosowac metody to dalej,
         if (resolution_res==FALSE)
		 {
//DeniseMessage(handle,"* RESULT: FALSE (continue)");
			 continue;
		 }

//DeniseMessage(handle,"* RESULT: TRUE (optymalizacja)");

         // optymizacja klauzuli (opisu)
         if (count_logic_facts(clause_res.opis)>1)
		 {
//DeniseMessage(handle,"*************** optymalizuje START ...");
			 clause_optimize(handle,&clause_res);
/*DeniseMessage(handle,"*************** optymalizuje END...");

for (chwila[0]='\0',p1=0;p1<(int) strlen(clause_res.opis);p1++)
{
	if (clause_res.opis[p1]>='A' && clause_res.opis[p1]<='Z')
	     strncat(chwila,clause_res.fs[clause_res.opis[p1]-'A']->sentence->base_words,20);
	else strncat(chwila,clause_res.opis+p1,1);

	strcat(chwila," ");
}
DeniseMessage(handle,"*** OPTYMALIZACJA: %s",chwila);
*/
		 }
//		 else DeniseMessage(handle,"* max. jeden fakt: %s",clause_res.opis);

         // jesli w wyniku powstala klauzula pusta NULL to zwracamy RETURN FALSE,
         if (clause_res.opis[0]=='\0')
         {
            // dopisujemy na koncu klauzule pusta, zeby bylo wiadomo skad sie wziela
            // tworzymy nowa klauzule
            clause=malloc(sizeof(struct LogicClause));
            clause->next=NULL;

            clause->opis[0]='\0';
            clause->parent[0]=clauseA;
            clause->parent[1]=clauseB;
            clause->type=IS_FACT;

            clause->next=cmp_end->next;
            cmp_end->next=clause;
            return FALSE;
         }

         // jesli w wyniku powstala nowa klauzula to:
         // sprawdzamy, czy ta klauzula juz jest na liscie, a jesli nie, to
         // dopisujemy ja w czesci przewidzianej dla nowych klauzul (od cmp_end),

         exist=FALSE;
         for (clause=head;clause!=NULL;clause=clause->next)
         {
            // sprawdzamy strukture opisu
            if (strlen(clause->opis)!=strlen(clause_res.opis)) continue;

            for (nr1=0;nr1<(int) strlen(clause_res.opis);nr1++)
            {
               if (clause->opis[nr1]>='A' && clause->opis[nr1]<='Z' &&
                   clause_res.opis[nr1]>='A' && clause_res.opis[nr1]<='Z')
               {
                  // jesli klauzula jest juz na liscie to pomijamy ja
                  if (log_fscmp(handle,clause->fs[clause->opis[nr1]-'A'],clause_res.fs[clause_res.opis[nr1]-'A'],CMP_ALL_GROUPS)!=FCMP_A_EQU_B) goto NEXT_CLAUSE_CHECK;
               }
               else if (clause->opis[nr1]!=clause_res.opis[nr1]) goto NEXT_CLAUSE_CHECK;
            }
            exist=TRUE;
            break;
            NEXT_CLAUSE_CHECK:;
         }

         // jesli nie ma klauzuli na liscie, to dodajemy ja
         if (exist==FALSE)
         {
            // tworzymy nowa klauzule
            clause=malloc(sizeof(struct LogicClause));
            clause->next=NULL;

            strcpy(clause->opis,clause_res.opis);
            for (nr1=0;nr1<10;nr1++) clause->fs[nr1]=clause_res.fs[nr1];
            clause->parent[0]=clauseA;
            clause->parent[1]=clauseB;
            clause->type=IS_FACT;

            clause->next=cmp_end->next;
            cmp_end->next=clause;
         }
      }
   }

   // po pobraniu wszystkich klauzul, sprawdzamy, czy sa jakies nowe
   // (tj. czy cmp_end->next jest rozne od NULL), jesli sa nowe, to ustawiamy
   // cmp_start na cmp_end->next, i skaczemy na START,
   if (cmp_end!=NULL)
      if (cmp_end->next!=NULL)
      {
         cmp_start=cmp_end->next;
         goto START;
      }

   return TRUE;
}

static BOOL resolution(struct DeniseHandle* handle,struct LogicClause *clause1,struct LogicClause *clause2,struct LogicClause *result)
{
   /*
   funkcja porownuje dwie klauzule, i zwraca TRUE jesli metoda rezolucji udalo
   sie wyeliminowac jakis czynnik, a do result jest wpisany wynik (moze to byc NULL!)
   zwraca FALSE, jesli nie udalo sie wyeliminowac zadnego czynnika,

   funkcja akceptuje klauzule zbudowane w dowolny (poprawny) sposob, poprawnie
   pracujac z klauzulami bardziej zlozonymi - patrz przyklady ponizej,

   B and C
   not (C and B) = not C or not B

   mamy liste klauzul:
   B
   C
   not C or not B

   sprawdzamy czy sa sprzeczne, wykorzystujac te same funkcje co wczesniej (rekurencyjnie),

   np.:
   B and C (marek ma AND marek jest)
   not (C and D) = not C or not D (NOT (marek ma AND darek jest))

   mamy liste:
   B (marek ma)
   C (marek jest)
   not C or not D (NOT marek ma OR NOT darek jest)
   ...
   baza nie jest sprzeczna (sprawdz metoda rezolucji)

   ale jesli D=B:
   B (marek ma)
   C (marek jest)
   not C or not B (NOT marek ma OR NOT darek jest)

   sprawdzamy metoda rezolucji:
   B + not C or not B = not C
   C + not C = NULL, wiec SPRZECZNE, wiec mozna wyeliminowac czynniki metoda rezolucji

   inny przyklad:
   A and B or C
   not A or D -> C or D ?

   wykazanie, ze tak:

   marek ma AND marek jest OR szymon ma (1)
   NOT marek ma OR darek ma (2)

   wyjasnienie: skoro "marek ma" nie jest prawda (2), to z (1) wynika, ze "szymon ma"
   a "marek ma" i "marek jest" sa sprzeczne do NOT "marek ma", wiec:
   "szymon ma" OR "darek ma"

   algorytm:
   - pobieramy z opisu kolejne czesci oddzielone spojnikiem OR z clause1,
      - zamieniamy pobrany opis na klauzule i tworzymy z nich liste,
      - pobieramy z opisu kolejne czesci oddzielone spojnikiem OR z clause2,
         - zamieniamy pobrany opis na klauzule i dodajemy je do listy,
         - jesli na liscie sa tylko 2 klauzule (po jednej z clause1 i clause2),
           to porownujemy je (beda to praktycznie 2 fakty ew. ze NOTami) log_fscmp():
            - jesli sa sprzeczne, to redukujemy metoda rezolucji a pozostale czesci z obu opisow klauzul
              laczymy ze soba (moze to byc zbior pusty NULL), kasujemy liste klauzul,
              oraz dokonujemy optymizacji zapisu klauzuli i RETURN TRUE
         - jesli jest ich wiecej to sprawdzamy sprzecznosc wywolujac deductive_data_check:
            - jesli baza sprzeczna, to wykrylismy elementy, ktore mozna zredukowac,
              wiec redukujemy metoda rezolucji a pozostale czesci z obu opisow klauzul
              laczymy ze soba (moze to byc zbior pusty NULL), kasujemy liste klauzul,
              oraz dokonujemy optymizacji zapisu klauzuli i RETURN TRUE
         - kasujemy dodane klauzule utworzone z czesci pobranej z clause2,
      - kasujemy liste klauzul,
   - RETURN FALSE
   */

   struct LogicClause *clauses_hd=NULL; // lista klauzul
   char text1[50],text2[50],temp1[1000],temp2[1000],opis1[1000],opis2[1000];
   int part1,part2,ile1,ile2,counter1,counter2,cmp_res,posnegA,posnegB;
   int nr1;
//char chwila[1000];
//int p1;

   result->opis[0]='\0';

   // sprawdzamy, czy w klauzulach wystepuja nawiasy, jesli tak, to nie mozemy stosowac metody
   if (strchr(clause1->opis,'(')!=NULL || strchr(clause2->opis,'(')!=NULL)
   {
      DeniseReport(handle,"wykryto zbyt skomplikowana klauzule, prosze to zglosic");
      return FALSE;
   }

   ile1=glo_count_parts(handle,clause1->opis,CON_OR+'1'-1);
   ile2=glo_count_parts(handle,clause2->opis,CON_OR+'1'-1);

   // pobieramy z opisu kolejne czesci oddzielone spojnikiem OR z clause1,
   for (part1=0;part1<ile1;part1++)
   {
      glo_get_part(clause1->opis,part1+1,text1,CON_OR+'1'-1);
      // zamieniamy pobrany opis na klauzule i tworzymy z nich liste,
//DeniseMessage(handle,"3: %s",text1);
      log_expr2clause(handle,text1,temp1);

      if (strlen(temp1)==0)
      {
         DeniseReport(handle,"dziwna klauzula 1 - to raczej blad");
         continue;
      }

      // dopisujemy fakt w postaci klauzul do listy klauzul,
      clauses_hd=NULL;

      if ((counter1=copy_clauses(handle,&clauses_hd,temp1,clause1,IS_FACT))==-1)
      {
      	return FALSE;
      }

      // pobieramy z opisu kolejne czesci oddzielone spojnikiem OR z clause2,
      for (part2=0;part2<ile2;part2++)
      {
         glo_get_part(clause2->opis,part2+1,text2,CON_OR+'1'-1);

         // zamieniamy pobrany opis na klauzule i dodajemy je do listy,
//DeniseMessage(handle,"4: %s",text2);
         log_expr2clause(handle,text2,temp1);

         if (strlen(temp1)==0)
         {
            DeniseReport(handle,"dziwna klauzula 2 - to raczej blad");
            continue;
         }

//clauses=NULL;
//if ((counter1=copy_clauses(handle,&clauses,temp1,clause1,IS_FACT))==-1) return FALSE;

         // dopisujemy fakt w postaci klauzul do listy klauzul,
         if ((counter2=copy_clauses(handle,&clauses_hd,temp1,clause2,IS_FACT))==-1)
         {
         	return FALSE;
         }

         // jesli na liscie sa tylko 2 klauzule (po jednej z clause1 i clause2),
         if (counter1==1 && counter2==1)
         {
            // to porownujemy je (beda to praktycznie 2 fakty ew. ze NOTami) log_fscmp():
//cmp_res=text1[0]-'1'+1==CON_NOT ? text1[1]-'A' : text1[0]-'A';
//cmp_res=text2[0]-'1'+1==CON_NOT ? text2[1]-'A' : text2[0]-'A';

			 cmp_res=log_fscmp(handle,clause1->fs[text1[0]-'1'+1==CON_NOT ? text1[1]-'A' : text1[0]-'A'],clause2->fs[text2[0]-'1'+1==CON_NOT ? text2[1]-'A' : text2[0]-'A'],CMP_ALL_GROUPS);

			 
//printf("fscmp_res: %s=%s - %d\n",clause1->fs[text1[0]-'1'+1==CON_NOT ? text1[1]-'A' : text1[0]-'A']->sentence->base_words,clause2->fs[text2[0]-'1'+1==CON_NOT ? text2[1]-'A' : text2[0]-'A']->sentence->base_words,cmp_res);
            posnegA=text1[0]-'1'+1==CON_NOT ? NEGATIV : POSITIV;
            posnegB=text2[0]-'1'+1==CON_NOT ? NEGATIV : POSITIV;
//printf("posnegA: %d, posnegB: %d, cmp_res: %d\n",posnegA,posnegB,cmp_res);
            // jesli sa sprzeczne, to redukujemy metoda rezolucji a pozostale czesci z obu opisow klauzul
            // warunki sprzecznosci dwoch faktow prostych: posnegA A i posnegB B
            if ((cmp_res==FCMP_A_EQU_B_NEG && posnegA==posnegB) ||
                (cmp_res==FCMP_A_EQU_B && posnegA!=posnegB) ||
                (cmp_res==FCMP_A_PR_B && posnegA==POSITIV && posnegB==NEGATIV) ||
                (cmp_res==FCMP_B_PR_A && posnegA==NEGATIV && posnegB==POSITIV) ||
                (cmp_res==FCMP_A_PR_B_NEG && posnegA==NEGATIV && posnegB==NEGATIV) ||
                (cmp_res==FCMP_B_PR_A_NEG && posnegA==NEGATIV && posnegB==NEGATIV) ||
                (cmp_res==FCMP_A_IN_B_NEG && posnegA==posnegB) ||
                (cmp_res==FCMP_B_IN_A_NEG && posnegA==posnegB) ||
                (cmp_res==FCMP_A_PR_B_NEG && posnegA==NEGATIV && posnegB==NEGATIV) ||
                (cmp_res==FCMP_B_PR_A_NEG && posnegA==NEGATIV && posnegB==NEGATIV) ||
                (cmp_res==FCMP_B_IN_A && posnegA==POSITIV && posnegB==NEGATIV) ||
                (cmp_res==FCMP_A_IN_B && posnegA==NEGATIV && posnegB==POSITIV) ||
                // sprawdzic kiedys
                (cmp_res==FCMP_A_IN_B && posnegA!=posnegB && clause1->type==IS_HYPOTHESIS && clause2->type==IS_FACT) ||
                (cmp_res==FCMP_B_IN_A && posnegA!=posnegB && clause1->type==IS_FACT && clause2->type==IS_HYPOTHESIS))
             {
               // laczymy ze soba (moze to byc zbior pusty NULL), kasujemy liste klauzul,
               // oraz dokonujemy optymizacji zapisu klauzuli i RETURN TRUE
/*
DeniseMessage(handle,"sprzeczne nr: %d z %d, opis1: %s, opis2: %s",part1+1,part2+1,clause1->opis,clause2->opis);
for (chwila[0]='\0',p1=0;p1<(int) strlen(clause1->opis);p1++)
{
	if (clause1->opis[p1]>='A' && clause1->opis[p1]<='Z')
	     strncat(chwila,clause1->fs[clause1->opis[p1]-'A']->sentence->base_words,20);
	else strncat(chwila,clause1->opis+p1,1);

	strcat(chwila," ");
}
DeniseMessage(handle,"1: %s",chwila);

for (chwila[0]='\0',p1=0;p1<(int) strlen(clause2->opis);p1++)
{
	if (clause2->opis[p1]>='A' && clause2->opis[p1]<='Z')
	     strncat(chwila,clause2->fs[clause2->opis[p1]-'A']->sentence->base_words,20);
	else strncat(chwila,clause2->opis+p1,1);

	strcat(chwila," ");
}
DeniseMessage(handle,"2: %s",chwila);
*/
//DeniseMessage(handle,"%s z %s",clause1->fs[part1]->sentence->base_words,clause2->fs[part2]->sentence->base_words);

				opis1[0]='\0';
               for (nr1=0;nr1<ile1;nr1++)
               {
                  if (nr1==part1) continue;

                  glo_get_part(clause1->opis,nr1+1,temp1,CON_OR+'1'-1);
                  if (opis1[0]=='\0') sprintf(temp2,"%s",temp1);
                  else sprintf(temp2,"%d%s",CON_OR,temp1);
                  strcat(opis1,temp2);
               }

               opis2[0]='\0';
               for (nr1=0;nr1<ile2;nr1++)
               {
                  if (nr1==part2) continue;

                  glo_get_part(clause2->opis,nr1+1,temp1,CON_OR+'1'-1);
                  if (opis2[0]=='\0') sprintf(temp2,"%s",temp1);
                  else sprintf(temp2,"%d%s",CON_OR,temp1);
                  strcat(opis2,temp2);
               }

               join_clauses(handle,clause1,opis1,clause2,opis2,result);
/*
DeniseMessage(handle,"opis wynikowy: %s+%s=%s",opis1,opis2,result->opis);

for (chwila[0]='\0',p1=0;p1<(int) strlen(result->opis);p1++)
{
	if (result->opis[p1]>='A' && result->opis[p1]<='Z')
	     strncat(chwila,result->fs[result->opis[p1]-'A']->sentence->base_words,20);
	else strncat(chwila,result->opis+p1,1);

	strcat(chwila," ");
}
DeniseMessage(handle,"res: %s (RETURN TRUE)",chwila);
*/
			   log_clauses_free(&clauses_hd);
               return TRUE;
            }
         }
         // jesli jest ich wiecej to sprawdzamy sprzecznosc wywolujac deductive_data_check:
         // jesli baza sprzeczna, to wykrylismy elementy, ktore mozna zredukowac,
         else
         {
//DeniseMessage(handle,"*******START*******");
            if (deductive_data_check(handle,clauses_hd)==FALSE)
            {
//DeniseMessage(handle,"*******END*******");
               // wiec redukujemy metoda rezolucji a pozostale czesci z obu opisow klauzul
               // laczymy ze soba (moze to byc zbior pusty NULL), kasujemy liste klauzul i RETURN TRUE
//DeniseMessage(handle,"sprzeczne nr: %d z %d, opis1: %s, opis2: %s",part1+1,part2+1,clause1->opis,clause2->opis);
				
				if (glo_count_parts(handle,clause1->opis,CON_OR+'1'-1)>1)
               {
                  strcpy(opis1,clause1->opis);
                  glo_delete_part_sep(handle,opis1,part1+1,CON_OR+'1'-1);
               }
               else opis1[0]='\0';

               if (glo_count_parts(handle,clause2->opis,CON_OR+'1'-1)>1)
               {
                  strcpy(opis2,clause2->opis);
                  glo_delete_part_sep(handle,opis2,part2+1,CON_OR+'1'-1);
               }
               else opis2[0]='\0';

               join_clauses(handle,clause1,opis1,clause2,opis2,result);

//DeniseMessage(handle,"opis wynikowy: %s+%s=%s",opis1,opis2,result->opis);

               log_clauses_free(&clauses_hd);
               return TRUE;
            }
         }

         // kasujemy dodane klauzule utworzone z czesci pobranej z clause2,
//log_clauses_free(clauses);
//clauses=NULL;

         del_clauses(&clauses_hd,counter2);
      }

      // kasujemy liste klauzul,
      log_clauses_free(&clauses_hd);
      //clauses=NULL;
   }

   return FALSE;
}

static void clause_optimize(struct DeniseHandle *handle,struct LogicClause *clause)
{
   /*
   funkcja dokonuje optymalizacji klauzuli, tj. redukuje nadmiarowe symbole, np.:
   "A and A" sprowadza do "A"
   "A and not A" sprowadza do klauzuli pustej (NULL)

   algorytm:
   - pobieramy kolejne wyrazenia ORowe (oznaczamy jako A),
      - zamieniamy na klauzule i tworzymy z nich liste,
      - pobieramy wyrazenie ORowe (oznaczamy jako B) poczynajac od nastepujacego po A,
         - zamieniamy na klauzule i dodajemy do listy,
         - sprawdzamy:
            - jesli PRAWDA - to kasujemy jeden element z opisu klauzuli (A lub B),
                             i skaczemy do NEXT_A,
            - jesli SPRZECZNOSC - to kasujemy oba elementy z opisu (A i B), i do NEXT_A,
            - jesli BRAK_DANYCH - to sprawdzamy dalej,
         - skaczemy do pobierania kolejnych wyrazen B, jesli sa,
      - NEXT_A: kasujemy liste, i skaczemy na START;

   funkcja wymaga optymalizacji w skokach do START1 i START2 - nalezy zmyslniej usuwac elementy,
   */

   struct LogicClause *clauses_head;
   char orA[1000],orB[1000],temp1[1000],temp2[1000];
   int nrA,nrB,nr1,nr2,start1,start2,depth,new_clauses;

   START1:
   // pobieramy z opisu kolejne ORy z clause,
   start1=0; depth=0; nrA=0;
   for (nr1=0;nr1<(int) strlen(clause->opis);nr1++)
   {
      if (clause->opis[nr1]=='(') depth++;
      else if (clause->opis[nr1]==')') depth--;

      if (depth==0 && (clause->opis[nr1]-'1'+1==CON_OR || nr1==(int) strlen(clause->opis)-1))
      {
         if (nr1==(int) strlen(clause->opis)-1) sprintf(orA,"%.*s",nr1-start1+1,clause->opis+start1);
         else sprintf(orA,"%.*s",nr1-start1,clause->opis+start1);

         nrA++;

         // zamieniamy na klauzule i tworzymy z nich liste,
//DeniseMessage(handle,"OPTI: orA: %s",orA);
         log_expr2clause(handle,orA,temp1);
         clauses_head=NULL;
         if (copy_clauses(handle,&clauses_head,temp1,clause,IS_FACT)==-1)
         {
            printf("blad 14 (logic1)\n");
            return;
         }

         // pobieramy z opisu kolejne ORy poczynajac od nastepnego po orA,
         start2=nr1+1; depth=0; nrB=nrA;
         for (nr2=nr1+1;nr2<(int) strlen(clause->opis);nr2++)
         {
            if (clause->opis[nr2]=='(') depth++;
            else if (clause->opis[nr2]==')') depth--;

            if (depth==0 && (clause->opis[nr2]-'1'+1==CON_OR || nr2==(int) strlen(clause->opis)-1))
            {
               if (nr2==(int) strlen(clause->opis)-1) sprintf(orB,"%.*s",nr2-start2+1,clause->opis+start2);
               else sprintf(orB,"%.*s",nr2-start2,clause->opis+start2);

               nrB++;

               // negujemy, zamieniamy na klauzule i dopisujemy do listy,
               sprintf(temp2,"%d(%s)",CON_NOT,orB);
//DeniseMessage(handle,"6: %s",temp2);
               log_expr2clause(handle,temp2,temp1);
               new_clauses=copy_clauses(handle,&clauses_head,temp1,clause,IS_FACT);
               if (new_clauses==-1)
               {
                  printf("blad fatalny 13 (logic1)\n");
                  return;
               }

//               printf("orA: %s, orB: %s\n",orA,orB);

               // sprawdzamy:
               // jesli lista jest sprzeczna, tzn. ze orA i orB wynikaja z siebie,
               // wiec usuwamy z opisu orB i skaczemy na START2
               if (deductive_data_check(handle,clauses_head)==FALSE)
               {
//DeniseMessage(handle,"OPTI: orA: %s sprzeczne z orB: %s (nrA: %d, nrB: %d)",orA,orB,nrA,nrB);
//DeniseMessage(handle,"orA 1: %s",clause->opis);
//printf("%s->",clause->opis);
                  if (glo_count_parts(handle,clause->opis,CON_OR+'1'-1)>1)
				  {
					  glo_delete_part_sep(handle,clause->opis,nrA,CON_OR+'1'-1);
				  }
                  else clause->opis[0]='\0';
//DeniseMessage(handle,"orA 2: %s",clause->opis);
//printf("%s\n",clause->opis);
                  log_clauses_free(&clauses_head);
//                  clauses_head=NULL;
                  goto START1;
               }
               // jesli lista nie jest sprzeczna, to...
               else
               {
                  // usuwamy dodane klauzule z orB
                  del_clauses(&clauses_head,new_clauses);
               }

               start2=nr2+1;
            }
         }
         start1=nr1+1; depth=0;
         log_clauses_free(&clauses_head);
         //clauses_head=NULL;
      }
   }
}

static void join_clauses(struct DeniseHandle* handle,struct LogicClause *clause1,char *opis1,struct LogicClause *clause2,char *opis2,struct LogicClause *result)
{
   /*
   funkcja tworzy nowa klauzule z polaczenia opisow dwoch innych klauzul,
   dobierajac nowa numeracje faktow w klauzuli, np.: A or B + A or C = A or B or C or D
   */

   int nr1,nr2,start1,start2,poz;
	struct FactSimple *fs[10];
	char opis[100];


	if (result==NULL)
   {
   	DeniseReport(handle,"wybryki... join_clauses logic1");
   	return;
   }
   result->opis[0]='\0';

   if (strlen(opis1)==0 && strlen(opis2)==0) return;

   if (strlen(opis1)==0)
   {
	   strcpy(result->opis,opis2);
/*      for (nr1=0;nr1<10;nr1++) result->fs[nr1]=clause2->fs[nr1];
      return;
*/
		// szukamy kolejnych symboli od A do Z
	   // dopisujemy je kolejno, bez przeskokow
		poz=0;
	   for (nr1='A';nr1<'Z';nr1++)
	   {
			result->fs[poz]=NULL;
		   // dla wszystkich faktow
			for (nr2=0;nr2<(int) strlen(opis2);nr2++)
			{
				if (opis2[nr2]==nr1)
				{
					if (result->fs[poz]==NULL)
					{
						result->fs[poz]=clause2->fs[nr1-'A'];
						poz++;
					}
					result->opis[nr2]='A'+poz-1;
				}
			}
	   }
	   return;
   }

   if (strlen(opis2)==0)
   {
      strcpy(result->opis,opis1);
/*      for (nr1=0;nr1<10;nr1++) result->fs[nr1]=clause1->fs[nr1];
      return;
*/ 
		// szukamy kolejnych symboli od A do Z
	   // dopisujemy je kolejno, bez przeskokow
		poz=0;
	   for (nr1='A';nr1<'Z';nr1++)
	   {
			result->fs[poz]=NULL;
		   // dla wszystkich faktow
			for (nr2=0;nr2<(int) strlen(opis1);nr2++)
			{
				if (opis1[nr2]==nr1)
				{
					if (result->fs[poz]==NULL)
					{
						result->fs[poz]=clause1->fs[nr1-'A'];
						poz++;
					}
					result->opis[nr2]='A'+poz-1;
				}
			}
	   }
	   return;
   }

   // wpisanie klauzuli 1
   // szukamy najnizszego numeru faktu w pobranej czesci
   start1=-1; start2=-1;
   for (nr1=0;nr1<(int) strlen(opis1);nr1++)
   {
      if (opis1[nr1]>='A' && opis1[nr1]<='Z')
      {
         if (start1==-1 || start1>opis1[nr1]-'A') start1=opis1[nr1]-'A';
         if (opis1[nr1]-'A'>start2) start2=opis1[nr1]-'A';
      }
   }
   start2++;
   start2=start2-start1;

   for (nr1=0;nr1<(int) strlen(opis1);nr1++)
   {
      if (opis1[nr1]>='A' && opis1[nr1]<='Z')
      {
         result->opis[nr1]=opis1[nr1]-start1;
         result->fs[opis1[nr1]-'A'-start1]=clause1->fs[opis1[nr1]-'A'];
      }
      else result->opis[nr1]=opis1[nr1];
   }
   result->opis[nr1]=CON_OR+'1'-1;

   start1=-1;
   for (nr1=0;nr1<(int) strlen(opis2);nr1++)
   {
      if (opis2[nr1]>='A' && opis2[nr1]<='Z')
         if (start1==-1 || start1>opis2[nr1]-'A') start1=opis2[nr1]-'A';
   }

   for (nr1=0,nr2=(int) strlen(opis1)+1;nr1<(int) strlen(opis2);nr1++,nr2++)
   {
      if (opis2[nr1]>='A' && opis2[nr1]<='Z')
      {
         result->opis[nr2]=opis2[nr1]-start1+start2;
         result->fs[opis2[nr1]-'A'-start1+start2]=clause2->fs[opis2[nr1]-'A'];
      }
      else result->opis[nr2]=opis2[nr1];
   }
   result->opis[nr2]='\0';

   // optymalizacja - zeby nie bylo luk!!!
   strcpy(opis,result->opis);
	for (nr1=0;nr1<10;nr1++)
	{
		fs[nr1]=result->fs[nr1];
		result->fs[nr1]=NULL;
	}
	poz=0;
   for (nr1='A';nr1<'Z';nr1++)
   {
	   // dla wszystkich faktow
		for (nr2=0;nr2<(int) strlen(opis);nr2++)
		{
			if (opis[nr2]==nr1)
			{
				if (result->fs[poz]==NULL)
				{
					result->fs[poz]=fs[nr1-'A'];
					poz++;
				}
				result->opis[nr2]='A'+poz-1;
			}
		}
   }
}

static int add_clauses(struct DeniseHandle *handle,struct LogicClause **head,char *nowy,struct Fact *fact,int type)
{
   /*
   funkcja dopisuje klauzule pobierane z ciagu tekstowego NEW (klauzule oddzielone przecinkiem)
   do listy klauzul HEAD, przy czym dopisane klauzule sa podanego typu TYPE
   (IS_FACT, IS_HYPOTHESIS)

   funkcja zwraca liczbe dopisanych klauzul, lub -1, w przypadku bledow,

   funkcja dopisuje klauzule NA POCZATKU (bardzo wazne, NIE MODYFIKOWAC TEGO!)
   */

   struct LogicClause *clause=NULL;
   int ile,nr1,nr2;

   ile=glo_count_parts(handle,nowy,',');
   for (nr1=0;nr1<ile;nr1++)
   {
      // tworzymy nowa klauzule
      if ((clause=malloc(sizeof(struct LogicClause)))==NULL) return -1;
      clause->next=NULL;

      if (glo_get_part(nowy,nr1+1,clause->opis,',')==0)
      {
         printf("blad: 1\n");
         return -1;
      }

      for (nr2=0;nr2<fac_count_fs(fact);nr2++) clause->fs[nr2]=fac_get_fs(fact,nr2+1);
      clause->parent[0]=NULL;
      clause->parent[1]=NULL;
      clause->type=type;

      // dolaczamy klauzule na poczatek listy
      if (*head==NULL) *head=clause;
      else
      {
         clause->next=*head;
         *head=clause;
      }
   }

   return ile;
}

static int copy_clauses(struct DeniseHandle *handle,struct LogicClause **head,char *nowy,struct LogicClause *src,int type)
{
   /*
   funkcja dopisuje klauzule pobierane z ciagu tekstowego NEW (klauzule oddzielone przecinkiem)
   do listy klauzul HEAD, przy czym dopisane klauzule sa podanego typu TYPE
   (IS_FACT, IS_HYPOTHESIS)

   funkcja zwraca liczbe dopisanych klauzul, lub -1, w przypadku bledow,

   funkcja dopisuje klauzule NA POCZATKU (bardzo wazne, NIE MODYFIKOWAC TEGO!)

   funkcja rozni sie od funkcji add_clauses() tym, ze fakty proste pobierane sa nie z faktu,
   ale z klauzuli zrodlowej (stad nazwa: COPY - kopiowanie),
   */

	struct FactSimple *fs[10];
   struct LogicClause *clause=NULL;
   int ile,nr1,nr2;

   ile=glo_count_parts(handle,nowy,',');
   if (src==NULL) return -1;

   for (nr1=0;nr1<10;nr1++)
	{
   	fs[nr1]=src->fs[nr1];
   }

   for (nr1=0;nr1<ile;nr1++)
   {
      // tworzymy nowa klauzule
      if ((clause=malloc(sizeof(struct LogicClause)))==NULL) return -1;
      clause->next=NULL;

      if (glo_get_part(nowy,nr1+1,clause->opis,',')==0)
      {
         printf("blad: 1\n");
         return -1;
      }

      for (nr2=0;nr2<10;nr2++)
      {
	     	clause->fs[nr2]=fs[nr2];
      }

      clause->parent[0]=NULL;
      clause->parent[1]=NULL;
      clause->type=type;

      // dolaczamy klauzule na poczatek listy
      if (*head==NULL) *head=clause;
      else
      {
         clause->next=*head;
         *head=clause;
      }
   }

   return ile;
}

static void del_clauses(struct LogicClause **head,int ile)
{
   /*
   funkcja kasuje z listy klauzul (head) ILE klauzul
   kasowanie obejmuje ILE pierwszych klauzul
   */

   struct LogicClause *clause;
   int nr1;

   for (nr1=0;nr1<ile;nr1++)
   {
      if (*head==NULL)
      {
         printf("ups o la la!\n");
         break;
      }

      clause=*head;
      *head=clause->next;
      free(clause);
   }
}

static void fact_pack(struct Fact *fact,char *result)
{
   /*
   funkcja tworzy wyrazenie, laczac wszystkie fakty proste faktu za pomoca
   operatora AND, dodajac przy tym konieczne nawiasy,
   */

   char temp[1000];
   int nr1;

   result[0]='\0';
   for (nr1=0;nr1<fact->ile_klauzul;nr1++)
   {
      if (nr1>0)
      {
         sprintf(temp,"%d",CON_AND);
         strcat(result,temp);
      }

      if (count_logic_facts(fact->logic[nr1])==1) sprintf(temp,"%s",fact->logic[nr1]);
      else sprintf(temp,"(%s)",fact->logic[nr1]);

      strcat(result,temp);
   }
}

static int database2clause(struct DeniseHandle *handle,struct LogicClause **head)
{
   /*
   tworzymy liste klauzul na podstawie wszystkich baz faktow
   */

   struct LogicClause *clause,*last_clause=NULL;
   struct FactDatabase *database;
   struct Fact *fact;
   int nr1,nr2,ile;

   if (handle->facts==NULL) return 0;

   // tworzymy liste klauzul na podstawie faktow w bazach
   ile=0;
   for (database=handle->facts;database!=NULL;database=database->next)
   {
      for (fact=database->facts;fact!=NULL;fact=fact->next)
      {
         for (nr1=0;nr1<fact->ile_klauzul;nr1++)
         {
            if ((clause=malloc(sizeof(struct LogicClause)))==NULL)
            {
               log_clauses_free(head);
               return 0;
            }
            clause->next=NULL;

            strcpy(clause->opis,fact->logic[nr1]);
            for (nr2=0;nr2<fac_count_fs(fact);nr2++)
               clause->fs[nr2]=fac_get_fs(fact,nr2+1);

            clause->type=IS_FACT; // fakt
            clause->parent[0]=NULL;
            clause->parent[1]=NULL;

            // dopisanie klauzuli do listy
            if (*head==NULL) *head=clause;
            else last_clause->next=clause;
            last_clause=clause;

            ile++;
         }
      }
   }

   return ile;
}

// ***************************************************************************************
// EXTERN        int log_fscmp(DeniseHandle*,FactSimple *fsA,FactSimple *fsB,mode)
// ***************************************************************************************
int log_fscmp(struct DeniseHandle* handle,struct FactSimple *fsA,struct FactSimple *fsB,int mode)
{
   /*
   funkcja porownuje dwa fakty proste (fact simple), w oparciu o dane zapisane w
   pliku "logic/factscmp.dat", przechowywane w pamieci w handle->logic.factscmp,

	mode:
   - CMP_ALL_GROUPS
   - CMP_WITHOUT_SUBJECT

   w wyniku zwracany jest stan:
   FCMP_A_DIF_B 2
   FCMP_A_EQU_B 3
   FCMP_A_IN_B 4
   FCMP_B_IN_A 5
   FCMP_A_PR_B 6
   FCMP_B_PR_A 7
   FCMP_A_EQU_B_NEG 8
   FCMP_A_IN_B_NEG 9
   FCMP_B_IN_A_NEG 10
   FCMP_A_PR_B_NEG 11
   FCMP_B_PR_A_NEG 12

   algorytm:
   - pobieramy kolejne grupy zgodnie ze struktura (od poziomu 0 w dol),
     pomijamy przy tym wyrazy negujace wyrazenie,
     UWAGA: jesli to grupa podmiotowa, to sprawdzamy temat, i wynikiem
     porownania jest temat,
   - porownujemy grupy:
      - musza pelnic te same funkcje w zdaniu,
      - wyrazy podstawowe:
         - pobieramy kolejne wyrazy fleksyjne obu grup:
            - porownujemy je, i korzystajac z tablicy przejsc
              zmieniamy result lub wychodzimy z funkcji,
   - zwracamy wynik (aktualny stan)
   */

   struct Theme *theme1,*theme2;
   struct FactsCMPData *fcmp;
   char grupy1[100][100],grupy2[100][100];
   char fleks1[100][100],fleks2[100][100];
   char *ident1,*ident2;
   int nr1,poziom,grA,grB,groups_max,founded;
   int state,posnegA,posnegB,cmp_res;

   state=FCMP_NULL;
   theme1=NULL;
   theme2=NULL;

   // rozpoznanie jaki typ informacji jest zawarty w fsA i fsB
   if (fsA==NULL || fsB==NULL)
   {
      DeniseReport(handle,"blad! zostaly podane fakty puste - NULL!");
      return FCMP_A_DIF_B;
   }

   if (fsA==fsB) return FCMP_A_EQU_B;

   // jezyki musza byc zgodne
   if (strcmp(fsA->sentence->language,fsB->sentence->language)!=0) return FCMP_A_DIF_B;

   // odszukujemy identyfikatory

   if (fsA->theme_number==0) ident1=fsA->sentence->id_subject;
   else if (fsA->theme_number>0)
   {
      theme1=ide_find_theme(handle,fsA->databaseID,fsA->theme_number);
      if (theme1==NULL) ident1=NULL;
      else ident1=theme1->identify;
   }
   else if (fsA->theme_number<0) return FCMP_NULL;

   if (fsB->theme_number==0) ident2=fsB->sentence->id_subject;
   else if (fsB->theme_number>0)
   {
      theme2=ide_find_theme(handle,fsB->databaseID,fsB->theme_number);
      if (theme2==NULL) ident2=NULL;
      else ident2=theme2->identify;
   }
   else if (fsB->theme_number<0) return FCMP_NULL;

   // pobieramy wszystkie grupy z fsA
   for (nr1=0;nr1<fsA->sentence->groups_number;nr1++)
      get_group_without_neg(handle,fsA,nr1+1,grupy1[nr1],fleks1[nr1]);

   // pobieramy wszystkie grupy z fsB
   for (nr1=0;nr1<fsB->sentence->groups_number;nr1++)
      get_group_without_neg(handle,fsB,nr1+1,grupy2[nr1],fleks2[nr1]);

   // pobieramy grupy z kolejnych poziomow
   groups_max=max(fsA->sentence->groups_number,fsB->sentence->groups_number);
   for (poziom=0;poziom<groups_max;poziom++)
   {
      // pobieramy numer grupy z fsA
      founded=0;
      for (nr1=0;nr1<fsA->sentence->groups_number;nr1++)
      {
         // jesli poziom 0 to szukamy podmiotu
         if (poziom==0) {if (fsA->sentence->parent[nr1]==0) {grA=nr1;founded=1;break;}}
         else {if (fsA->sentence->parent[nr1]==grA+1) {grA=nr1;founded=1;break;}}
      }
      // jesli nie znaleziono grupy to podajemy posnegA=FCMP_NULL
      if (founded==0) posnegA=FCMP_NULL;
      else posnegA=fsA->sentence->posneg[grA]==TWIERDZENIE ? POSITIV : NEGATIV;

      // pobieramy numer grupy z fsB
      founded=0;
      for (nr1=0;nr1<fsB->sentence->groups_number;nr1++)
      {
         // jesli poziom 0 to szukamy podmiotu
         if (poziom==0) {if (fsB->sentence->parent[nr1]==0) {grB=nr1;founded=1;break;}}
         else {if (fsB->sentence->parent[nr1]==grB+1) {grB=nr1;founded=1;break;}}
      }
      // jesli nie znaleziono grupy to podajemy posnegB=FCMP_NULL
      if (founded==0) posnegB=FCMP_NULL;
      else posnegB=fsB->sentence->posneg[grB]==TWIERDZENIE ? POSITIV : NEGATIV;

      // porownujemy grupy, jesli istnieja
      if (posnegA!=FCMP_NULL && posnegB!=FCMP_NULL)
      {
         // * funkcje
         if (fsA->sentence->function[grA]!=fsB->sentence->function[grB]) return FCMP_A_DIF_B;

         // * porownanie tresci grup
         // jesli poziom 0 to identyfikacja tematow
         if (poziom==0)
         {
				if (mode==CMP_WITHOUT_SUBJECT)
            {
            	cmp_res=FCMP_A_EQU_B;
            }
            else
            {
	            if (theme1==theme2 && theme1!=NULL)
	            {
//printf("1: ");
	               cmp_res=FCMP_A_EQU_B;
	            }
	            else if (fsA->theme_number==0 && fsB->theme_number>0)
	            {
//printf("2: ");
	               cmp_res=ide_accept_theme(handle,theme2,ident1); // B, A
	            }
	            else if (fsB->theme_number==0 && fsA->theme_number>0)
	            {
//printf("3: ");
	               cmp_res=ide_accept_theme(handle,theme1,ident2); // B, A
	               if (cmp_res==FCMP_A_IN_B) cmp_res=FCMP_B_IN_A;
	               else if (cmp_res==FCMP_B_IN_A) cmp_res=FCMP_A_IN_B;
	               else if (cmp_res==FCMP_B_PR_A) cmp_res=FCMP_A_PR_B;
	               else if (cmp_res==FCMP_A_PR_B) cmp_res=FCMP_B_PR_A;
	            }
   	         else if (fsA->theme_number>0 && fsB->theme_number>0)
	            {
//printf("4: ");
	               cmp_res=ide_accept_theme(handle,theme2,ident1); // B, A
	            }
	            else
	            {
//printf("5: ");
		            cmp_res=cmp_groups(handle,grupy1[grA],fleks1[grA],grupy2[grB],fleks2[grB]);
//	               cmp_res=FCMP_A_DIF_B;
	            }
				}
//printf("cmp_res: %s=%s - %d\n",ident1,ident2,cmp_res);
         }
         // w przeciwnym razie porownanie zwykle
         else
         {
            cmp_res=cmp_groups(handle,grupy1[grA],fleks1[grA],grupy2[grB],fleks2[grB]);
//printf("cmp_res: %s (%s) = %s (%s) - %d\n",grupy1[grA],fleks1[grA],grupy2[grB],fleks2[grB],cmp_res);
         }
      }
      else cmp_res=FCMP_NULL;
//DeniseMessage(handle,"cmp_res: %s=%s - %d",grupy1[grA],grupy2[grB],cmp_res);

      // szukamy reprezentacji aktualnej sytuacji w bazie i odpowiednio reagujemy
      for (fcmp=handle->logic.factscmp;fcmp!=NULL;fcmp=fcmp->next)
      {
         if (fcmp->state!=state) continue;
         if (fcmp->posnegA!=posnegA) continue;
         if (fcmp->posnegB!=posnegB) continue;
         if (fcmp->cmp_res!=cmp_res) continue;
         if (fcmp->groups==CMP_ALL || (fcmp->groups==CMP_ONLY_PREDICATE && poziom==1) || (fcmp->groups==CMP_WITHOUT_PREDICATE && poziom!=1))
         {
            state=fcmp->new_state;
            if (fcmp->operation==OPERATION_NEXT) goto NEXT;
            else return state;
         }

/*
         if (fcmp->state==state && fcmp->posnegA==posnegA && fcmp->posnegB==posnegB && fcmp->cmp_res==cmp_res &&
             (fcmp->groups==CMP_ALL || (fcmp->groups==CMP_ONLY_PREDICATE && poziom==1) || (fcmp->groups==CMP_WITHOUT_PREDICATE && poziom!=1)))
         {
            state=fcmp->new_state;
            if (fcmp->operation==OPERATION_NEXT) goto NEXT;
            else return state;
         }
*/
      }
		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_STATE_NOT_FOUND,"nie zostalo opracowane przejscie dla danego stanu logicznego"));
		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_UNKNOWN_STATE,"state: %d, posnegA: %d, posnegB: %d, cmp_res: %d"),state,posnegA,posnegB,cmp_res);
      return FCMP_A_DIF_B;

      NEXT:;
   }

   return state;
}

static int cmp_groups(struct DeniseHandle *handle,char *podstA,char *fleksA,char *podstB,char *fleksB)
{
   /*
   funkcja porownuje TRESC obu grup

   algorytm:
   - zerujemy tablice equal,
   - kasujemy spojniki AND
   - rozpoznajemy typ polaczenia wyrazow w grupie (kolejno w obu):
      - odszukujemy w grupie operatora logicznego: AND, OR itp.,
      - jesli znaleziono jakis spojnik inny niz AND, to zaznaczamy typ==1
        (typ==0 - AND, 1 - inny) i konczymy sprawdzanie,
   - pobieramy kolejne wyrazy z grupy A,
      - pobieramy kolejne wyrazy z grupy B pomijajac te, ktore juz wykorzystano,
         - porownujemy wyrazy:
            - jesli sa rowne, to ustawiamy odpowiednie pole equal, i NEXT A
            - jesli sa rozne i kwantyfikator nie byl wykorzystywany, to
              sprawdzamy kwantyfikatory:
               - jesli sa zgodne ze soba, to ustawiamy odpowiedni wynik, pole equal, i NEXT A
               - jesli nie sa zgodne to pobieramy kolejny wyraz z grupy B (NEXT B)
            - w przeciwnym razie nastepny wyraz z grupy B (NEXT B)
         - jesli pobrano wszystkie wyrazy z grupy B i nie znaleziono zgodnego,
            - to jesli grupa B jest krotsza, to kontynuujemy szukanie,
            - a jesli nie jest krotsza to zwracamy wynik FCMP_A_DIF_B
      - NEXT A - skaczemy do pobierania kolejnego wyrazu z grupy A,
	- UWAGA: w przypadku, gdy grupy okazuja sie rozne, przeprowadzany jest test
	  znaczeniowy, ktorego kod znajduje sie na koncu funkcji;
	  wynikiem testu moze byc tylko FCMP_A_DIF_B lub FCMP_A_EQU_B,
	- MEANING_TEST:
		- pobieramy kolejne pary tozsamosciowe z bazy znaczen,
			- sprawdzamy, czy wyrazy z grupy A pasuja do lewej lub do prawej czesci,
			- jesli TAK, to:
				- sprawdzamy, czy wyrazy z grupy B pasuja do przeciwnej czesci,
				- jesli TAK, to return FCMP_A_EQU_B,

   przyklad wykorzystania dowolnej kolejnosci:
   ktos kims jest.
   ktos jest kims.

   z kwantyfikatorami i z odwrotna kolejnoscia:
   marek jest czlowiekiem.
   ktos kims jest?

   funkcja zwraca:
   FCMP_A_DIF_B 2
   FCMP_A_EQU_B 3
   FCMP_A_IN_B 4
   FCMP_B_IN_A 5
   FCMP_A_PR_B 6
   FCMP_B_PR_A 7
   */

	struct Meaning *mean;
	struct GrammarData *gra;
	char posneg=TWIERDZENIE;
	char equal[2][100]; // 1 - wyraz sie zgadza
	char temp1[100],temp2[100],temp3[100],temp4[100];
	int nr1,nr2,nr3,ileA,ileB,kwant=FCMP_NULL,res,typeA=0,typeB=0;

   // kasujemy spojnik AND
   kasuj_spojnik_and(handle,podstA,fleksA);
   kasuj_spojnik_and(handle,podstB,fleksB);

   // rozpoznajemy typ polaczenia wyrazow w grupie (kolejno w obu):
   for (nr1=0;nr1<2;nr1++)
   {
      ileA=glo_count_parts(handle,nr1==0 ? podstA : podstB,',');
      for (nr2=0;nr2<ileA;nr2++)
      {
         glo_get_part(nr1==0 ? fleksA : fleksB,nr2+1,temp1,',');

         // sprawdzamy dane w bazie gramatycznej (nie sprawdzamy ANDow)
         for (nr3=1;nr3<2;nr3++)
            for (gra=handle->language.lo2[nr3];gra!=NULL;gra=gra->next)
            {
               // sprawdzamy zgodnosc
               if (gra_wyrazenie_check(handle,&posneg,gra->data,temp1)==0) continue;

               // jesli znaleziono jakis spojnik inny niz AND, to zaznaczamy typ==1
               // (type==0 - AND, 1 - inny) i konczymy sprawdzanie,
               if (nr1==0) typeA=1;
               else if (nr1==1) typeB=1;
               goto NEXT_GROUP;
            }
      }
      NEXT_GROUP:;
   }

//printf("typA: %d, typB: %d\n",typeA,typeB);

   ileA=glo_count_parts(handle,podstA,',');
   ileB=glo_count_parts(handle,podstB,',');

   // jesli grupy nie sa zwykle ANDowe, i roznia sie dlugoscia, to to oceniamy jako rozne
//   if ((typeA==1 || typeB==1) && ileA!=ileB) return FCMP_A_DIF_B;
   if ((typeA==1 || typeB==1) && ileA!=ileB) goto MEANING_TEST;

   // zerujemy tablice equal,
   memset(equal[0],(char) 0,ileA); // dla grupy A
   memset(equal[1],(char) 0,ileB); // dla grupy B

   // pobieramy kolejne wyrazy z grupy A,
   for (nr1=0;nr1<ileA;nr1++)
   {
      glo_get_part(podstA,nr1+1,temp1,',');
      glo_get_part(fleksA,nr1+1,temp2,',');

      // pobieramy kolejne wyrazy z grupy B pomijajac te, ktore juz wykorzystano,
      for (nr2=0;nr2<ileB;nr2++)
      {
         if (equal[1][nr2]==1) continue;

         glo_get_part(podstB,nr2+1,temp3,',');

         // porownujemy wyrazy:
         // jesli sa rowne, to ustawiamy odpowiednie pole equal, i NEXT A
         if (strcmp(temp1,temp3)==0)
         {
            equal[0][nr1]=1;
            equal[1][nr2]=1;
            goto FOUNDED;
         }

         // jesli kwantyfikator byl wykorzystywany, to nie mozna wykorzystac go drugi raz
         if (kwant!=FCMP_NULL) continue;

         // jesli sa rozne i kwantyfikator nie byl wykorzystywany, to
         // sprawdzamy kwantyfikatory:
         glo_get_part(fleksB,nr2+1,temp4,',');
         res=log_cmp_kwantyfikatory(handle,temp2,temp4);
//printf("kwant: %s=%s <-> %s=%s - %d\n",temp1,temp3,temp2,temp4,res);

         // jesli sa zgodne ze soba, to ustawiamy odpowiedni wynik, pole equal, i NEXT A
         if (res!=FCMP_A_DIF_B)
         {
            kwant=res;
            equal[0][nr1]=1;
            equal[1][nr2]=1;
            goto FOUNDED;
         }
         // jesli nie sa zgodne to pobieramy kolejny wyraz z grupy B (NEXT B)
      }
      // jesli pobrano wszystkie wyrazy z grupy B i nie znaleziono zgodnego,
      // to jesli grupa B jest krotsza, to kontynuujemy szukanie,
      if (ileB<ileA) continue;
      // a jesli nie jest krotsza:
      // to zwracamy wynik FCMP_A_DIF_B
//      else return FCMP_A_DIF_B;
      else goto MEANING_TEST;

      FOUNDED:;
   }

   // jesli liczba wyrazow w grupie jest rozna, to
   if (ileA!=ileB)
   {
      // sprawdzamy, czy w mniejszej grupie znaleziono wszystkie wyrazy
      nr2=ileA<ileB ? 0 : 1;
      ileA=min(ileA,ileB);
      for (nr1=0;nr1<ileA;nr1++)
//         if (equal[nr2][nr1]==0) return FCMP_A_DIF_B;
         if (equal[nr2][nr1]==0) goto MEANING_TEST;

      // jesli znaleziono to wynik zawsze jest x_IN_y
      if (kwant==FCMP_NULL)
      {
         if (ileA<ileB) return FCMP_A_IN_B;
         else return FCMP_B_IN_A;
      }
   }

   if (kwant==FCMP_NULL) return FCMP_A_EQU_B;
   if (kwant==FCMP_A_DIF_B) goto MEANING_TEST;
   return kwant;

	// test znaczeniowy (od 5.1)
	MEANING_TEST:;

	// pobieramy kolejne pary tozsamosciowe z bazy znaczen,
	for (mean=handle->meanings;mean!=NULL;mean=mean->next)
	{
		// sprawdzamy, czy wyrazy z grupy A pasuja do lewej lub do prawej czesci,
		// musi sie zgadzac liczba wyrazow w grupie z liczba wyrazow po lewej stronie
		if (glo_count_parts(handle,podstA,',')==mean->basisA_number)
		{
			for (nr1=0;nr1<mean->basisA_number;nr1++)
				if (glo_get_part_position(1,podstA,mean->basisA[nr1],',')==0) goto A_NOT_FOUND_ON_LEFT;

			// jesli TAK, to:
			// sprawdzamy, czy wyrazy z grupy B pasuja do przeciwnej czesci,
			if (glo_count_parts(handle,podstB,',')==mean->basisB_number)
			{
				for (nr1=0;nr1<mean->basisB_number;nr1++)
					if (glo_get_part_position(1,podstB,mean->basisB[nr1],',')==0) goto A_NOT_FOUND_ON_LEFT;

				// jesli TAK, to return FCMP_A_EQU_B,
				return FCMP_A_EQU_B;
			}
			A_NOT_FOUND_ON_LEFT:;
		}

		// szukamy od prawej
		if (glo_count_parts(handle,podstA,',')==mean->basisB_number)
		{
			for (nr1=0;nr1<mean->basisB_number;nr1++)
				if (glo_get_part_position(1,podstA,mean->basisB[nr1],',')==0) goto A_NOT_FOUND_ON_RIGHT;

			// jesli TAK, to:
			// sprawdzamy, czy wyrazy z grupy B pasuja do przeciwnej czesci,
			if (glo_count_parts(handle,podstB,',')==mean->basisA_number)
			{
				for (nr1=0;nr1<mean->basisA_number;nr1++)
					if (glo_get_part_position(1,podstB,mean->basisA[nr1],',')==0) goto A_NOT_FOUND_ON_RIGHT;

				// jesli TAK, to return FCMP_A_EQU_B,
				return FCMP_A_EQU_B;
			}
			A_NOT_FOUND_ON_RIGHT:;
		}

	}
//DeniseMessage(handle,"!%s!%s!",podstA,podstB);
	return FCMP_A_DIF_B;
}

static void kasuj_spojnik_and(struct DeniseHandle *handle,char *podst,char *fleks)
{
   /*
   funkcja kasuje spojnik AND
   */

   struct GrammarData *log;
   char temp1[100],posneg=TWIERDZENIE;
   int nr1,ile;

   START:
   for (nr1=0,ile=glo_count_parts(handle,podst,',');nr1<ile;nr1++)
   {
      glo_get_part(fleks,nr1+1,temp1,',');

      // sprawdzamy dane w bazie gramatycznej
      for (log=handle->language.lo2[0];log!=NULL;log=log->next)
      {
         // sprawdzamy zgodnosc
         if (gra_wyrazenie_check(handle,&posneg,log->data,temp1)==1)
         {
            if (glo_count_parts(handle,fleks,',')>1)
            {
               glo_delete_part_sep(handle,fleks,nr1+1,',');
               glo_delete_part_sep(handle,podst,nr1+1,',');
            }
            else
            {
               fleks[0]='\0';
               podst[0]='\0';
            }
            goto START;
         }
      }
   }
}

// ***************************************************************************************
// EXTERN               int log_cmp_kwantyfikatory(handle,daneA,daneB)
// ***************************************************************************************
int log_cmp_kwantyfikatory(struct DeniseHandle* handle,char *daneA,char *daneB)
{
   /*
   funkcja porownuje dwa wyrazy (fleksje) i zwraca wartosci:
?   - FCMP_A_EQU_B: EXIST=EXIST (ktos=ktos), ALL=ALL (kazdy=kazdy)
   - FCMP_A_EQU_B: NO_EXIST_NO+poprawny_wyraz (nikt+marek), poprawny_wyraz+NO_EXIST_NO (marek+nikt),
              NO_EXIST_NO+EXIST (nikt+ktos), EXIST+NO_EXIST_NO (ktos+nikt),
   - FCMP_A_NOT_B: NO_EXIST+poprawny_wyraz (nobody+marek), poprawny_wyraz+NO_EXIST (marek+nobody),
              NO_EXIST+EXIST (nobody+someone), EXIST+NO_EXIST (someone+nobody),
   - FCMP_A_PR_B: poprawny_wyraz+EXIST (marek PRECUZYJE ktos), 
   - FCMP_B_PR_A: EXIST+poprawny_wyraz (marek PRECYZUJE ktos),
   - FCMP_A_IN_B: poprawny_wyraz+ALL (marek IN kazdy), (EXIST+ALL (ktos IN kazdy))
   - FCMP_B_IN_A: ALL+poprawny_wyraz (marek IN kazdy), (ALL+EXIST (ktos IN kazdy))
   - FCMP_A_DIF_B: w pozostalych przypadkach

   NO_EXIST_NO - wymagaja dalszego zaprzeczenia:
   nikt         nie ma   komputera
   marek/ktos   ma       komputer? <- A_EQU_B, NEG=TRUE

   wiec porownujac:
   nikt Z marek/ktos
   musimy podac wynik: FCMP_A_EQU_B, NEG=FALSE, bo pozniej NEG=TRUE i wszystko gra,

   algorytm:
   - pobieramy z bazy logicznej kolejne pozycje i sprawdzamy, czy sa zgodne z wyrazami:
      - jesli sa zgodne, i w bazie opisane jako ALL+WORD to return FCMP_B_IN_A
      - jesli sa zgodne, i w bazie opisane jako EXIST+WORD to return FCMP_B_PR_A
      - jesli sa zgodne, i w bazie opisane jako NO_EXIST_NO+WORD to return FCMP_A_EQU_B
      - jesli sa zgodne, i w bazie opisane jako NO_EXIST+WORD to return FCMP_A_NOT_B
      - jesli nie sa zgodne, to zmieniamy kolejnosc i sprawdzamy:
         - jesli sa zgodne, i w bazie opisane jako ALL+WORD to return FCMP_A_IN_B
         - jesli sa zgodne, i w bazie opisane jako EXIST+WORD to return FCMP_A_PR_B
         - jesli sa zgodne, i w bazie opisane jako NO_EXIST_NO+WORD to return FCMP_A_EQU_B
         - jesli sa zgodne, i w bazie opisane jako NO_EXIST+WORD to return FCMP_A_NOT_B
   - return FCMP_A_DIF_B

   funkcja korzysta przy tym z tablicy
   handle->language.lo3_voc_filter[czesc_mowy]=TRUE/FALSE;
   mowiacej, czy wyraz moze byc kwantyfikatorem, czy nie

   */

   struct GrammarData *log;
   char posneg=TWIERDZENIE;
   int nr1;
   BOOL kwantA=handle->language.lo3_voc_filter[daneA[0]-'A'+1];
   BOOL kwantB=handle->language.lo3_voc_filter[daneB[0]-'A'+1];

   if (kwantA==FALSE && kwantB==FALSE) return FCMP_A_DIF_B;

   // pobieramy z bazy logicznej kolejne pozycje (nr1: 0-ALL,1-EXIST,2-NO_EXIST,3-NO_EXIST_NO)
   for (nr1=0;nr1<4;nr1++)
   {
      for (log=handle->language.lo3[nr1];log!=NULL;log=log->next)
      {
         // sprawdzamy zgodnosc
         if (kwantA==TRUE)
         {
            if (gra_wyrazenie_check(handle,&posneg,log->data,daneA,daneB)==0)
            {
               // jesli nie sa zgodne, to zmieniamy kolejnosc i sprawdzamy:
               if (kwantB==FALSE) continue;
               if (gra_wyrazenie_check(handle,&posneg,log->data,daneB,daneA)==0) continue;

               // sa zgodne
               switch (nr1)
               {
                  // jesli sa zgodne, i w bazie opisane jako ALL+WORD to return FCMP_A_IN_B
                  case 0: return FCMP_A_IN_B;
                  // jesli sa zgodne, i w bazie opisane jako EXIST+WORD to return FCMP_A_PR_B
                  case 1: return FCMP_A_PR_B;
                  // jesli sa zgodne, i w bazie opisane jako NO_EXIST_NO+WORD to return FCMP_A_EQU_B
                  case 3: return FCMP_A_EQU_B;
               }
               continue;
            }

            // sa zgodne
            switch (nr1)
            {
               // jesli sa zgodne, i w bazie opisane jako ALL+WORD to return FCMP_B_IN_A
               case 0: return FCMP_B_IN_A;
               // jesli sa zgodne, i w bazie opisane jako EXIST+WORD to return FCMP_B_PR_A
               case 1: return FCMP_B_PR_A;
               // jesli sa zgodne, i w bazie opisane jako NO_EXIST_NO+WORD to return FCMP_A_EQU_B
               case 3: return FCMP_A_EQU_B;
            }
         }
         else
         {
            if (gra_wyrazenie_check(handle,&posneg,log->data,daneB,daneA)==0) continue;

            // sa zgodne
            switch (nr1)
            {
               // jesli sa zgodne, i w bazie opisane jako ALL+WORD to return FCMP_A_IN_B
               case 0: return FCMP_A_IN_B;
               // jesli sa zgodne, i w bazie opisane jako EXIST+WORD to return FCMP_A_PR_B
               case 1: return FCMP_A_PR_B;
               // jesli sa zgodne, i w bazie opisane jako NO_EXIST_NO+WORD to return FCMP_A_EQU_B
               case 3: return FCMP_A_EQU_B;
            }
            continue;
         }
      }
   }

   // sprawdzamy, czy to zaimki pytajace
   // pobieramy z drugiej bazy logicznej kolejne pozycje
   // wynik jest odpowiedni jak dla zaimkow nieokreslonych (EXIST)
   for (nr1=0;nr1<4;nr1++)
   {
      // pomijamy wyrazy, ktore preferuja odpowiedz, ale sa eliminowane ze zdania (WITHOUT_CON)
      if (nr1==1 || nr1==3) continue;

      for (log=handle->language.lo4[nr1];log!=NULL;log=log->next)
      {
         // sprawdzamy zgodnosc
         if (gra_wyrazenie_check(handle,&posneg,log->data,daneA,daneB)==0)
         {
            // jesli nie sa zgodne, to zmieniamy kolejnosc i sprawdzamy:
            if (gra_wyrazenie_check(handle,&posneg,log->data,daneB,daneA)==0) continue;

            // sa zgodne, to FCMP_A_PR_B
            return FCMP_A_PR_B;
         }

         // sa zgodne, FCMP_B_PR_A
         return FCMP_B_PR_A;
      }
   }

   return FCMP_A_DIF_B;
}

static void get_group_without_neg(struct DeniseHandle *handle,struct FactSimple *fs,int nr_grupy,char *result,char *res_fleks)
{
   /*
   funkcja zwraca wyrazy fleksyjne grupy, rozdzielone przecinkiem, z usunietymi
   wyrazami NEGujacymi wyrazenie,

   w res_fleks znajduja sie dane fleksyjne poszczegolnych wyrazow fleksyjnych,
   oddzielone przecinkiem,
   */

   char temp[100],temp1[100],temp2[100];
   int nr1,nr2,nr3;

   result[0]='\0';
   res_fleks[0]='\0';

   // pobieramy kolejne wyrazy fleksyjne nalezace do grupy
   for (nr1=0;nr1<fs->sentence->ile_fleks;nr1++)
   {
      // sprawdzamy, czy ten wyraz fleksyjny nalezy do badanej grupy
      for (nr2=0;nr2<fs->sentence->words_number;nr2++)
         if (fs->sentence->fleksyjny[nr2]==nr1+1 && fs->sentence->member[nr2]==nr_grupy) goto NALEZY;
      continue;

      // skoro nalezy, to dopisujemy go
      NALEZY: ;

      temp[0]='\0'; // tu bedzie dany wyraz fleksyjny

      // dopisujemy wszystkie elementy, pomijajac wyrazy negujace
      if (glo_get_part(fs->sentence->base_words,nr1+1,temp1,',')==0)
      {
         printf("blad: 3\n");
         continue;
      }
      if (strlen(temp1)==0) continue;
      nr3=glo_count_parts(handle,temp1,'+');
      for (nr2=0;nr2<nr3;nr2++)
      {
         // WYRAZY WYRAZU PODSTAWOWEGO
         // pobieramy element
         if (glo_get_part(temp1,nr2+1,temp2,'+')==0) printf("blad: 4\n");

         // jesli to NEGacja to pomijamy
         if (temp2[0]==NEG_WORD) continue;

         // w przeciwnym razie dopisujemy do wyrazu fleksyjnego
         strcat(temp,temp2);
      }

      // jesli jest cos do dopisania, to dopisujemy
      if (temp[0]=='\0') continue;

      if (result[0]=='\0') strcpy(result,temp);
      else
      {
         sprintf(temp1,",%s",temp);
         strcat(result,temp1);
      }

      // FLEKSJA
      glo_get_part(fs->sentence->voc,nr1+1,temp,',');
      if (res_fleks[0]=='\0') strcpy(res_fleks,temp);
      else
      {
         sprintf(temp1,",%s",temp);
         strcat(res_fleks,temp1);
      }
   }
}

static int count_logic_facts(char *expr)
{
   int nr1,ile=0,len;

   len=strlen(expr);
   for (nr1=0;nr1<len;nr1++)
      if (expr[nr1]>='A' && expr[nr1]<='Z') ile++;

   return ile;
}

static int count_clauses(struct LogicClause *head)
{
   struct LogicClause *clause;
   int number=0;

   for (clause=head;clause!=NULL;clause=clause->next,number++);
   return number;
}

// ***************************************************************************************
// EXTERN           void log_clauses_free(struct LogicClause **head)
// ***************************************************************************************
void log_clauses_free(struct LogicClause **head)
{
   struct LogicClause *clause,*clause_next;

   for (clause=*head;clause!=NULL;clause=clause_next)
   {
      clause_next=clause->next;
      free(clause);
   }
   *head=NULL;
}

// ***************************************************************************************
// EXTERN                 void log_cache_themes_free(list)
// ***************************************************************************************
void log_cache_themes_free(struct ThemesList *list)
{
   struct ThemesList *theme,*theme_next;

   for (theme=list;theme!=NULL;theme=theme_next)
   {
      theme_next=theme->next;
      free(theme);
   }
}
